package com.bcxin.sp.config.exception;

import com.bcxin.sp.work.service.log.LogService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.servlet.ModelAndView;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.io.PrintWriter;
import java.io.StringWriter;

@ControllerAdvice
@Slf4j
public class ExceptionInterceptor {

	@Resource
	private LogService logService;

	@ExceptionHandler(Exception.class)
	public ModelAndView handlerException(Exception ex, HttpServletRequest request) {
		ModelAndView view = new ModelAndView("/error");
		if(ex instanceof BusinessException){
			BusinessException be = (BusinessException) ex;
			view.addObject("errorMsg",be.getMsg());
		} else {
			view.addObject("errorMsg",ex.getMessage());
		}
		String exception = toString(ex);
		if (exception.length()>5000) {
			exception = exception.substring(0,5000);
		}
		logService.logException(exception);
		return view;
	}

	private static String toString(Throwable e){
		StringWriter sw = new StringWriter();
		PrintWriter pw = new PrintWriter(sw, true);
		e.printStackTrace(pw);
		pw.flush();
		sw.flush();
		return sw.toString();
	}

}
