/**
 * projectName: bcxin-signature
 * fileName: RefreshTokenTimer.java
 * packageName: com.bcxin.signature.config
 * date: 2019-09-10 17:30
 * copyright(c) 2015-2019 百川信
 */
package com.bcxin.sp.config.task.bim;


import cn.hutool.core.date.DateUnit;
import cn.hutool.core.date.DateUtil;
import com.bcxin.sp.work.controller.third.bim.BimController;
import com.bcxin.sp.work.util.sys.ConfigUtil;
import com.bimface.exception.BimfaceException;
import com.bimface.sdk.BimfaceClient;
import lombok.extern.slf4j.Slf4j;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.Date;

/**
 * @version: V1.0
 * @author: jianjun.wang
 * @className: RefreshTokenTimer
 * @description: 定时刷新token
 * @data: 2020-05-29 17:30
 **/
@Component
@Slf4j
@EnableScheduling
public class RefreshTokenTimer {

    //    private static AtomicInteger atomicInteger = new AtomicInteger();
    public static final Integer TWO_DAY = 2;//两天

    /**
     * 每天凌晨3点监测token时间是否小于2天
     */
    @Scheduled(cron = "0 0 3 * * ?")
//    @Scheduled(cron = "0 0/1 * * * ?")
    public void refreshToken() throws BimfaceException {
//        log.info("---------------------------定时任务开始---------------------执行第  " + atomicInteger.incrementAndGet() + "  次任务-------------------------");
        Date expireTime = DateUtil.parse(BimController.bimfaceClient.getAccessTokenService().getAccessTokenBean().getExpireTime());
        if (DateUtil.between(expireTime, new Date(), DateUnit.DAY) <= TWO_DAY) {
            BimController.bimfaceClient = new BimfaceClient(ConfigUtil.getValue("BIM_KEY"), ConfigUtil.getValue("BIM_SECRET"));
        }
    }

}