package com.bcxin.sp.work.controller.activity.session;

import com.bcxin.sp.config.annotation.AuditLogAn;
import com.bcxin.sp.config.annotation.OperLog;
import com.bcxin.sp.work.controller.sys.BaseController;
import com.bcxin.sp.work.dao.activity.extend.ActivitySessionMapper;
import com.bcxin.sp.work.entity.PageResult;
import com.bcxin.sp.work.entity.domain.activity.history.ActivityHistory;
import com.bcxin.sp.work.entity.domain.activity.session.ActivitySession;
import com.bcxin.sp.work.entity.domain.user.User;
import com.bcxin.sp.work.entity.dto.ActivityHistoryDTO;
import com.bcxin.sp.work.entity.dto.AjaxResult;
import com.bcxin.sp.work.entity.dto.SearchDto;
import com.bcxin.sp.work.service.activity.action.ActivityActionService;
import com.bcxin.sp.work.util.Const.DictConst;
import com.bcxin.sp.work.util.Const.MenuConst;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.Date;
import java.util.List;

/**
 * 上报活动审批
 */
@Controller
@RequestMapping("/business/activity/session")
public class ActivitySessionController extends BaseController {

    @Resource
    private ActivitySessionMapper activitySessionMapper;



    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.HDGL_CCCX)
    @RequestMapping("/list/{activityId}")
    @ResponseBody
    public SearchDto<ActivitySession> sessionList(@PathVariable("activityId") Long activityId) {
        List<ActivitySession> resultList = activitySessionMapper.selectByActivityId(activityId);
        SearchDto<ActivitySession> result = new SearchDto<ActivitySession>();
        result.setData(resultList);
        return result;
    }

    @AuditLogAn(operateType = DictConst.OP_SAVE,menuName = MenuConst.HDGL_CCLR)
    @RequestMapping("/createOrUpdate")
    public @ResponseBody
    AjaxResult createOrUpdate(ActivitySession ac, HttpServletRequest request) {
        User user = super.getCurrentUser(request);
//        ac.setUpdater(user.getUsername());
        AjaxResult result = new AjaxResult();
        ActivitySession as = null;
        if(ac.getId() != null){
            as = activitySessionMapper.selectById(ac.getId());
        }
        /*if(as == null){
            result.setSuccessful(false);
            result.setMsg("未找到有效场次");
            return result;
        }*/
        ac.setIsImprove(1);
        if(as == null){
            ac.setAddTime(new Date());
            activitySessionMapper.insert(ac);
        }else{
            ac.setAddTime(as.getAddTime());
            ac.setActivityId(as.getActivityId());
            activitySessionMapper.updateById(ac);
        }
        result.setSuccessful(true);
        result.setObj(ac);
        return result;
    }

    @AuditLogAn(operateType = DictConst.OP_DELETE,menuName = MenuConst.HDGL_CCSC)
    @RequestMapping("/delete/{id}")
    public @ResponseBody
    AjaxResult delete(@PathVariable("id") Long id,HttpServletRequest request) {
        User user = super.getCurrentUser(request);
        AjaxResult result = new AjaxResult();
        activitySessionMapper.deleteById(id);
        result.setSuccessful(true);
        return result;
    }

}
