package com.bcxin.sp.work.controller.log;

import com.bcxin.sp.work.entity.domain.upgrade.SystemUpgrade;
import com.bcxin.sp.work.entity.dto.AjaxResult;
import com.bcxin.sp.work.service.upgrade.SystemUpgradeService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 升级更新日志控制层
 */
@Controller
@RequestMapping("/upgrade/log")
@Slf4j
public class UpgradeLogController {

    @Autowired
    SystemUpgradeService upgradeService;

    @RequestMapping("list")
    public ModelAndView upgradeList(HttpServletRequest request) throws Exception {
        ModelAndView view = new ModelAndView("/log/upgradeList");
        List<SystemUpgrade> list=upgradeService.findAll();
        SimpleDateFormat df=new SimpleDateFormat("yyyy年MM月dd日");
        List<Map<String,String>> listMap=new ArrayList<>();
        for(SystemUpgrade upgrade : list) {
            Map<String, String> map = new HashMap();
            map.put("title",upgrade.getTitle());
            map.put("content",upgrade.getContent());
            map.put("id",upgrade.getId().toString());
            map.put("createDate",df.format(upgrade.getCreateTime()));
            listMap.add(map);
        }
        view.addObject("upgradeList",listMap);
        return view;
    }

    @RequestMapping("select/{id}")
    @ResponseBody
    public AjaxResult selectById(@PathVariable("id") Long id){
        AjaxResult result=new AjaxResult();
        SystemUpgrade upgrade=upgradeService.findById(id);
        result.setSuccessful(true);
        result.setObj(upgrade);
        return result;
    }
}
