package com.bcxin.sp.work.controller.sys;

import cn.hutool.core.lang.Console;
import com.bcxin.sp.work.entity.domain.activity.base.Activity;
import com.bcxin.sp.work.entity.domain.user.User;
import com.bcxin.sp.work.service.activity.approve.ApproveFileService;
import com.bcxin.sp.work.service.activity.base.ActivityService;
import com.bcxin.sp.work.service.sys.RepairService;
import com.bcxin.sp.work.timer.SyncZJService;
import com.bcxin.sp.work.util.Const.DictConst;
import com.zl.jwzh.yun.comm.Pzs;
import com.zl.jwzh.yun.comm.XMJHelp;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.HashMap;

/**
 * 修复，业务数据修复等
 */
@Controller
@RequestMapping("/repair")
@Slf4j
public class RepairController extends BaseController {

    @Resource
    private RepairService repairService;

    @Resource
    private SyncZJService syncZJService;
    @Resource
    private ApproveFileService approveFileService;

    @Resource
    private ActivityService activityService;

    /**
     * 修复中心
     * @param request
     * @return
     * @throws Exception
     */
    @RequestMapping("center")
    public ModelAndView center(HttpServletRequest request) throws Exception {
        ModelAndView view = new ModelAndView("/sys/repairCenter");
        return view;
    }


    /**
     * 重新生成许可审批表
     * @param request
     * @return
     * @throws Exception
     */
    @RequestMapping("aqxkspb")
    public ModelAndView aqxkspb(HttpServletRequest request) throws Exception {
        ModelAndView view = new ModelAndView("/common/opSuccess");
        try {
            boolean flag = repairService.repairAQXKSPB();
            if (!flag) {
                return new ModelAndView("/common/opFailure");
            }
        } catch (Exception e) {
            e.printStackTrace();
            ModelAndView failView =  new ModelAndView("/common/opFailure");
            failView.addObject("message",logException(e));
            return failView;
        }
        return view;
    }

    @RequestMapping("zj/user")
    public void syncZJUserData(){
        HashMap map = new HashMap();
        map.put("REQUESTID", Pzs.AC_REQUESTID);
        map.put("TOKEN", "122");
        map.put("FHLX", "2");
        String a = XMJHelp.mapToXml(map, "DATAS");
        Console.log(a);
    }


    private static String logException(Throwable e){
        StringWriter sw = new StringWriter();
        PrintWriter pw = new PrintWriter(sw, true);
        e.printStackTrace(pw);
        pw.flush();
        sw.flush();


        return sw.toString();
    }

    /**
     * 重新生成受理凭证
     * @param request
     * @return
     * @throws Exception
     */
    @RequestMapping("repslpz/{activityId}")
    public ModelAndView repslpz(@PathVariable("activityId") Long activityId,HttpServletRequest request) throws Exception {
        ModelAndView view = new ModelAndView("/common/opSuccess");
        try {
            Activity activity = activityService.findById(activityId);
            if (activity == null) {
                return new ModelAndView("/common/opFailure");
            }
            User user = super.getCurrentUser(request);
            /* 生成文书 */
            approveFileService.generateslws(DictConst.STATUS_SL, activity, user);
        } catch (Exception e) {
            e.printStackTrace();
            ModelAndView failView =  new ModelAndView("/common/opFailure");
            failView.addObject("message",logException(e));
            return failView;
        }
        return view;
    }

}
