package com.bcxin.sp.work.controller.sys;

import com.bcxin.sp.config.annotation.AuditLogAn;
import com.bcxin.sp.config.annotation.SysManageAuth;
import com.bcxin.sp.work.entity.domain.sys.SPMsgTemplate;
import com.bcxin.sp.work.entity.domain.user.User;
import com.bcxin.sp.work.entity.dto.AjaxResult;
import com.bcxin.sp.work.service.sys.SPMsgTemplateService;
import com.bcxin.sp.work.util.Const.DictConst;
import com.bcxin.sp.work.util.Const.MenuConst;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import java.text.ParseException;

/**
 * 行政服务，设置通知承办方去哪办理许可
 */
@Controller
@RequestMapping("/business/spMsgTemplate")
public class SPMsgTemplateController extends BaseController {

    @Autowired
    private SPMsgTemplateService SPMsgTemplateService;

    @RequestMapping("/initTab")
    @SysManageAuth(limitRole = DictConst.ROLE_APPROVE)
    public ModelAndView initTab(HttpServletRequest request) {
        ModelAndView view = new ModelAndView("/sys/spMsgTemplateTab");
        return view;
    }

    @RequestMapping("/initNew")
    @SysManageAuth(limitRole = DictConst.ROLE_APPROVE)
    public ModelAndView initNew(HttpServletRequest request) {
        ModelAndView view = new ModelAndView("/sys/spMsgTemplateNew");
        User user = super.getCurrentUser(request);
        SPMsgTemplate SPMsgTemplate = SPMsgTemplateService.findAdministrativeByArea(user);
        view.addObject("SPMsgTemplate", SPMsgTemplate);
        return view;
    }

    @RequestMapping("/init")
    public ModelAndView list(HttpServletRequest request) {
        ModelAndView view = new ModelAndView("/sys/spMsgTemplate");
        User user = super.getCurrentUser(request);
        SPMsgTemplate SPMsgTemplate = SPMsgTemplateService.findAdministrativeByArea(user);
        view.addObject("SPMsgTemplate", SPMsgTemplate);
        return view;
    }

    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.XTPZ_DXMB_SPDXMB_TJ)
    @RequestMapping("createOrUpdate")
    public @ResponseBody
    AjaxResult createOrUpdate(SPMsgTemplate SPMsgTemplate, HttpServletRequest request) throws ParseException {
        User user = super.getCurrentUser(request);
        SPMsgTemplate.setUpdater(user.getUsername());
        if ( SPMsgTemplate.getId() == null) {
            SPMsgTemplateService.save(SPMsgTemplate,user);
        } else {
            SPMsgTemplateService.update(SPMsgTemplate);
        }
        AjaxResult result = new AjaxResult();
        result.setSuccessful(true);
        result.setObj(SPMsgTemplate);
        return result;
    }

    @AuditLogAn(operateType = DictConst.OP_UPDATE,menuName = MenuConst.XTPZ_DXMB_SPDXMB_QY)
    @RequestMapping("enable")
    public @ResponseBody
    AjaxResult enable(HttpServletRequest request) throws ParseException {
        String id = request.getParameter("id");
        SPMsgTemplate SPMsgTemplate = SPMsgTemplateService.findById(Long.parseLong(id));
        SPMsgTemplate.setActive(DictConst.Y);
        SPMsgTemplateService.update(SPMsgTemplate);
        AjaxResult result = new AjaxResult();
        result.setSuccessful(true);
        result.setObj(SPMsgTemplate);
        return result;
    }

    @AuditLogAn(operateType = DictConst.OP_DELETE,menuName = MenuConst.XTPZ_DXMB_SPDXMB_TY)
    @RequestMapping("freeze")
    public @ResponseBody
    AjaxResult freeze(HttpServletRequest request) throws ParseException {
        String id = request.getParameter("id");
        SPMsgTemplate SPMsgTemplate = SPMsgTemplateService.findById(Long.parseLong(id));
        SPMsgTemplate.setActive(DictConst.N);
        SPMsgTemplateService.update(SPMsgTemplate);
        AjaxResult result = new AjaxResult();
        result.setSuccessful(true);
        result.setObj(SPMsgTemplate);
        return result;
    }

}
