package com.bcxin.sp.work.controller.sys;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.text.StrSpliter;
import com.bcxin.sp.config.annotation.AuditLogAn;
import com.bcxin.sp.work.entity.domain.user.User;
import com.bcxin.sp.work.entity.dto.AjaxResult;
import com.bcxin.sp.work.entity.dto.SearchDto;
import com.bcxin.sp.work.entity.dto.SummaryDto;
import com.bcxin.sp.work.service.statistic.SummaryService;
import com.bcxin.sp.work.util.Const.DictConst;
import com.bcxin.sp.work.util.Const.MenuConst;
import com.bcxin.sp.work.util.StringUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Controller
@RequestMapping("/business/summary")
public class SummaryController extends BaseController {
	
	@Autowired
	private SummaryService summaryService;

	/**
	 * 审批进度
	 * @param request
	 * @return
	 */
	@RequestMapping("/approvalProcess")
	public ModelAndView approvalProcess(HttpServletRequest request) {
		ModelAndView index = new ModelAndView("/statistic/approvalProcess");
		User user = super.getCurrentUser(request);
		Map<String, BigDecimal> map = summaryService.approvalSummary(user);
		index.addObject("result",map);
		index.addObject("now", DateUtil.now());
		return index;
	}

	/**
	 * 审批进度中的审批结果查询
	 * @param request
	 * @return
	 */
	@AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.TJZX_SPJDTJ)
	@RequestMapping("/approvalProcess/spjg")
	@ResponseBody
	public AjaxResult approvalProcessSPJG(HttpServletRequest request) {
		User user = super.getCurrentUser(request);
		AjaxResult result = new AjaxResult();
		/* 得到的值是 2018-07-01 - 2018-08-01 这种格式*/
		String date = request.getParameter("date");
		String beginDate="";
		String endDate="";
		if (StringUtil.isNotEmpty(date)) {
			List<String> dateList = StrSpliter.split(date," - ",true,true);
			beginDate = dateList.get(0);
			endDate = dateList.get(1);
		}
		Map<String, BigDecimal> map = summaryService.approvalSummarySPJG(user,beginDate,endDate);
		result.setSuccessful(true);
		result.setObj(map);
		return result;
	}

	@RequestMapping("/list")
	public ModelAndView list(HttpServletRequest request) {
		return new ModelAndView("/statistic/summary");
	}

	@AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.TJZX_HDSBTJ)
	@RequestMapping("findData")
	public @ResponseBody
	SearchDto<SummaryDto> findData(HttpServletRequest request,SearchDto<SummaryDto> dto) throws Exception {
		User currentUser = getCurrentUser(request);
		List<SummaryDto> data = summaryService.findSummary(dto,currentUser);
		long count = data.size();
		SearchDto<SummaryDto> result = new SearchDto<SummaryDto>();
		result.setData(data);
		result.setIDisplayStart(dto.getIDisplayStart());
		result.setIDisplayLength(dto.getIDisplayLength());
		result.setITotalRecords(count);
		result.setITotalDisplayRecords(count);
		return result;
	}


}
