/**
 * date: 2020-04-26 15:40
 * copyright(c) 2015-2020 百川信
 */
package com.bcxin.sp.work.controller.third.anbao;

import com.bcxin.sp.config.annotation.AuditLogAn;
import com.bcxin.sp.work.controller.sys.BaseController;
import com.bcxin.sp.work.entity.PageResult;
import com.bcxin.sp.work.entity.dto.ActivitySurveyDTO;
import com.bcxin.sp.work.entity.dto.SearchDto;
import com.bcxin.sp.work.entity.dto.accident.ActivitySurveySearchDTO;
import com.bcxin.sp.work.service.activity.survey.SurveyService;
import com.bcxin.sp.work.util.Const.DictConst;
import com.bcxin.sp.work.util.Const.MenuConst;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * @author: wangjianjun
 * @description:
 *  现场勘查态势
 * @data: 2020-04-26 15:40
 **/
@Controller
@RequestMapping("/thirdBusiness/anBaoActivitySurvey")
@Slf4j
public class AnBaoActivitySurveyController extends BaseController {

    @Resource
    private SurveyService surveyService;

    /**
     *
     *  现场勘查信息－页面
     *
     * @param
     * @return
     */
    @RequestMapping("/activitySurveyListView/{activityNo}")
    public ModelAndView jqsjListView(@PathVariable("activityNo") String activityNo, HttpServletRequest request) {
        ModelAndView index = new ModelAndView("/activity/anbao/survey/activitySurveyList");
        index.addObject("access_token",request.getParameter("access_token") );
        index.addObject("activityNo", activityNo);
        return index;
    }

    /**
     *
     *  现场勘查信息-列表
     * @param dto
     * @return
     */
    @AuditLogAn(operateType = DictConst.OP_SELECT, menuName = MenuConst.HDGL_GABA)
    @RequestMapping("findActivitySurveyListData")
    @ResponseBody
    public SearchDto<ActivitySurveyDTO> findActivityIsrListData(ActivitySurveySearchDTO dto) {
        PageResult pageResult = surveyService.findActivitySurveyList(dto);
        List<ActivitySurveyDTO> resultList = (List<ActivitySurveyDTO>) pageResult.getRows();
        SearchDto<ActivitySurveyDTO> result = new SearchDto<>();
        result.setData(resultList);
        result.setIDisplayStart(dto.getIDisplayStart());
        result.setIDisplayLength(dto.getIDisplayLength());
        result.setITotalRecords(pageResult.getTotal());
        result.setITotalDisplayRecords(pageResult.getTotal());
        return result;
    }

    /**
     *
     *  现场勘查信息-详情
     * @param id
     * @return
     */
    @AuditLogAn(operateType = DictConst.OP_SELECT, menuName = MenuConst.HDGL_GABA)
    @RequestMapping("findActivitySurveyDetailData/{id}")
    @ResponseBody
    public ActivitySurveyDTO findActivityPoliceIsrDetailData(@PathVariable("id") Long id) {
        return surveyService.findActivitySurveyDetail(id);
    }
}