package com.bcxin.sp.work.controller.third.anbao;

import cn.hutool.core.text.StrSpliter;
import com.alibaba.fastjson.JSON;
import com.bcxin.sp.config.annotation.AuditLogAn;
import com.bcxin.sp.config.annotation.OperLog;
import com.bcxin.sp.work.controller.sys.BaseController;
import com.bcxin.sp.work.entity.PageResult;
import com.bcxin.sp.work.entity.domain.activity.approve.Approve;
import com.bcxin.sp.work.entity.domain.activity.approve.ApproveDetail;
import com.bcxin.sp.work.entity.domain.activity.approve.ApproveHistory;
import com.bcxin.sp.work.entity.domain.activity.base.Activity;
import com.bcxin.sp.work.entity.domain.activity.expand.ActivityContractor;
import com.bcxin.sp.work.entity.domain.activity.expand.ActivityMaterial;
import com.bcxin.sp.work.entity.domain.sys.ConfigFunction;
import com.bcxin.sp.work.entity.domain.user.User;
import com.bcxin.sp.work.entity.dto.ActivityUtil;
import com.bcxin.sp.work.entity.dto.AjaxResult;
import com.bcxin.sp.work.entity.dto.ApproveUtil;
import com.bcxin.sp.work.entity.dto.SearchDto;
import com.bcxin.sp.work.service.activity.approve.ApproveFileService;
import com.bcxin.sp.work.service.activity.approve.ApproveService;
import com.bcxin.sp.work.service.activity.base.ActivityService;
import com.bcxin.sp.work.service.activity.extend.ActivityContractorService;
import com.bcxin.sp.work.service.activity.extend.WorkflowService;
import com.bcxin.sp.work.service.user.UserService;
import com.bcxin.sp.work.util.BcxinDateUtil;
import com.bcxin.sp.work.util.Const.DictConst;
import com.bcxin.sp.work.util.Const.GlobalConst;
import com.bcxin.sp.work.util.Const.MenuConst;
import com.bcxin.sp.work.util.StringUtil;
import com.bcxin.sp.work.util.WebUtil;
import com.bcxin.sp.work.util.sys.ApproveFileGenerator;
import com.bcxin.sp.work.util.sys.ConfigUtil;
import com.google.common.base.Strings;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.io.FileUtils;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.ModelAndView;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.io.File;
import java.io.IOException;
import java.text.ParseException;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 审批管理
 * @author 罗鹏
 */
@Controller
@RequestMapping("/thirdBusiness/anBaoApprove")
@Slf4j
public class AnBaoApproveController extends BaseController {

    @Resource
    private ActivityService activityService;

    @Resource
    private WorkflowService workflowService;

    @Resource
    private UserService userService;

    @Resource
    private ApproveService approveService;

    @Resource
    private ApproveFileService approveFileService;

    @Resource
    private ActivityContractorService activityContractorService;

    /**
     * 审批列表
     *
     * @param request
     * @return
     */
    @RequestMapping("list")
    public ModelAndView list(HttpServletRequest request) {
        ModelAndView index = new ModelAndView("/activity/anbao/approve/load");
        User user = super.getCurrentUser(request);
        index.addObject("access_token", request.getParameter("access_token"));
        index.addObject("user_name", user.getUsername());
        return index;
    }

    /**
     * 审批列表
     *
     * @param request
     * @return
     */
    @RequestMapping("list1")
    public ModelAndView list1(HttpServletRequest request) {
        ModelAndView index = new ModelAndView("/activity/anbao/approve/list");
        User user = super.getCurrentUser(request);
        index.addObject("access_token",request.getParameter("access_token") );
        index.addObject("user_name",user.getUsername() );
        index.addObject("communicateMode", ConfigUtil.getValue("pss-communicate-mode"));
        index.addObject("crole",user.getRole() );
        index.addObject("approveType", ApproveUtil.getApproveType());
        index.addObject("status",request.getParameter("status"));
        //隐藏左边菜单树标记
        index.addObject("hiddenLeft",request.getParameter("hiddenLeft"));
        //活动类型
        index.addObject("typeCode",request.getParameter("typeCode"));
        //市级编码
        index.addObject("city",request.getParameter("city"));
        //区县级编码
        index.addObject("area",request.getParameter("area"));
        //数据源
        index.addObject("dataSource",request.getParameter("dataSource"));
        //活动开始起始日期
        index.addObject("startDate",request.getParameter("startDate"));
        //活动开始截至日期
        index.addObject("endDate",request.getParameter("endDate"));
        /* 审批状态 */
        index.addObject("approveStatus",request.getParameter("approveStatus"));
        /* 审批状态汇总 */
        index.addObject("approveStatusSummary",request.getParameter("approveStatusSummary"));
        /* 时间区间 */
        if (StringUtil.isNotEmpty(request.getParameter("dateRange"))) {
            List<String> dateList = StrSpliter.split(request.getParameter("dateRange")," - ",true,true);
            String beginDate = dateList.get(0);
            String endDate = dateList.get(1);
            //活动开始起始日期
            index.addObject("addTimeStartDate",beginDate);
            //活动开始截至日期
            index.addObject("addTimeEndDate",endDate);
        }
        index.addObject("user",user);
        index.addObject("switchGradeRank",ConfigUtil.getValue("switch_gradeRank"));
        ConfigFunction configFunction = ConfigUtil.getFunction(user.getProvince());
        index.addObject("switchApprove",configFunction.getSwitchApprove());

        /* 判断当前用户是否是第一级审批人 */
        String isFirstApproveUser = DictConst.N;
        if (userService.isFirstApproveLevel(user)) {
            isFirstApproveUser = DictConst.Y;
        }
        index.addObject("isFirstApproveUser",isFirstApproveUser);
        index.addObject("myEnvi",ConfigUtil.getValue("envi"));
        index.addObject("switch_zjzw20",ConfigUtil.getValue("switch_zjzw20"));
        return index;
    }

    @RequestMapping("findData")
//    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.HDGL_XKHD)
    public @ResponseBody SearchDto<Activity> findData(HttpServletRequest request,SearchDto<Activity> dto) throws Exception {
        User user = getCurrentUser(request);
        dto.setGov(false);
        /* 查出所有的记录 */
        PageResult pageResult = activityService.findApproveByUser(dto);
        List<Activity> resultList = activityService.authApprove(user,(List<Activity>)pageResult.getRows());
        SearchDto<Activity> result = new SearchDto<Activity>();
        result.setData(resultList);
        result.setIDisplayStart(dto.getIDisplayStart());
        result.setIDisplayLength(dto.getIDisplayLength());
        result.setITotalRecords(pageResult.getTotal());
        result.setITotalDisplayRecords(pageResult.getTotal());
        return result;
    }

    @RequestMapping("activityApproveUserList/{activityId}")
    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.HDGL_XKHD_SPYH)
    public @ResponseBody Activity activityApproveUserList(@PathVariable("activityId") Long activityId, HttpServletRequest request) {
        return activityService.activityApproveUserList(activityId);
    }

    @RequestMapping("findNextApprover/{activityId}")
    public @ResponseBody List<User> findNextApprover(@PathVariable("activityId") int activityId, HttpServletRequest request) {
        User user = super.getCurrentUser(request);
        Activity activity = activityService.findById(activityId);
        return workflowService.findNextUser(user,activity);
    }

    @RequestMapping("findLastApprover/{activityId}")
    public @ResponseBody
    Approve findLastApprover(@PathVariable("activityId") Long activityId) {
        return approveService.findLastByActivityId(activityId);
    }


    /**
     * 审批
     * @param approve
     * @param nextApprover
     * @param checkDates
     * @param situations
     * @param request
     * @return
     * @throws ParseException
     */
    @RequestMapping("save")
    @OperLog(menuName = "许可活动",operateType = "#approve",operateTypeMethod="transferApprove", operateObj = "#approve.activityId")
//    @AuditLogAn(operateType = DictConst.OP_UPDATE,menuName = MenuConst.HDGL_XKHD_SP)
    public @ResponseBody AjaxResult save(Approve approve, Long nextApprover, String[] checkDates, String[] situations, HttpServletRequest request) throws ParseException {
        User user = super.getCurrentUser(request);
        approve.setUserId(user.getId());
        approve.setUpdater(user.getRealName());

        String[] checkIndexs = request.getParameterValues("checkIndexs");

        int loop = checkDates.length;
        loop = situations.length > loop ? situations.length : loop;
        String rejectContent = request.getParameter("rejectContent");
        for (int i = 0; i < loop; i++) {
            ApproveDetail detail = new ApproveDetail();
            if (checkDates.length > i) {
                String checkDate = checkDates[i];
                if (Strings.isNullOrEmpty(checkDate)) {
                    detail.setCheckDate(new Date());
                } else {
                    Date cd = BcxinDateUtil.systemDate.parse(checkDate);
                    detail.setCheckDate(cd);
                }
            } else {
                detail.setCheckDate(new Date());
            }
            if (situations.length > i) {
                detail.setSituation(situations[i]);
            }
            detail.setAddTime(new Date());
            detail.setUpdateTime(new Date());
            detail.setUpdater(user.getRealName());

            String[] imgPaths = request.getParameterValues("imgPaths"+checkIndexs[i]);
            StringBuffer imgPathBuffer = new StringBuffer();
            if (imgPaths != null) {
                for(String imgPath : imgPaths){
                    if(imgPathBuffer.length() > 0){
                        imgPathBuffer.append( "&&" + imgPath);
                    }else{
                        imgPathBuffer.append(imgPath);
                    }
                }
                detail.setImgPath(imgPathBuffer.toString());
            }
            approve.getDetails().add(detail);
        }
        //未填写检查记录，默认添加一条空数据
        if (loop <= 0) {
            ApproveDetail detail = new ApproveDetail();
            detail.setAddTime(new Date());
            detail.setUpdateTime(new Date());
            approve.getDetails().add(detail);
        }

        return workflowService.moveNext(user,approve, nextApprover, rejectContent);
    }

    @RequestMapping("downloadApproveFile/{activityId}")
    public ResponseEntity<byte[]> downloadApproveFile(@PathVariable("activityId") Long activityId) throws IOException {
        Activity activity = activityService.findById(activityId);
        if (activity != null) {
            File file = ApproveFileGenerator.generateApproveFile(activity);
            if (file != null) {
                HttpHeaders headers = new HttpHeaders();
                headers.setContentType(MediaType.APPLICATION_OCTET_STREAM);
                String fileName = new String("大型群众性活动审批许可书.docx".getBytes("GBK"), "ISO-8859-1");
                headers.setContentDispositionFormData("attachment", fileName);
                try {
                    return new ResponseEntity<byte[]>(FileUtils.readFileToByteArray(file), headers, HttpStatus.OK);
                } catch (IOException e) {
                    log.error(e.getMessage());
                    e.printStackTrace();
                    return null;
                }
            }
        }
        return null;
    }


    @RequestMapping("downloadSupervisionCheck/{activityId}")
    public ResponseEntity<byte[]> downloadSupervisionCheck(@PathVariable("activityId") Long activityId) throws IOException {
        Activity activity = activityService.findById(activityId);
        ActivityMaterial material = activityService.findMaterialByActivity(activityId);
        if (activity != null && !StringUtils.isEmpty(material.getJljcb())) {
            HttpHeaders headers = new HttpHeaders();
            headers.setContentType(MediaType.APPLICATION_OCTET_STREAM);
            String stuffPath = ConfigUtil.getValue("stuff-path") + material.getJljcb();
            String fileName = material.getJljcb();
            String fileType = fileName.substring(fileName.lastIndexOf("."), fileName.length());
            File file = new File(stuffPath);
            if (file != null) {
                String customFileName = new String((activity.getFullName() + "检查表" + fileType).getBytes("GBK"), "iso-8859-1");
                headers.setContentDispositionFormData("attachment", customFileName);
                try {
                    return new ResponseEntity<byte[]>(FileUtils.readFileToByteArray(file), headers, HttpStatus.OK);
                } catch (IOException e) {
                    log.error(e.getMessage());
                    e.printStackTrace();
                    return null;
                }
            }
        }
        return null;
    }


    @RequestMapping("downloadSupervisionReport/{activityId}")
    public ResponseEntity<byte[]> downloadSupervisionReport(@PathVariable("activityId") Long activityId) throws IOException {
        Activity activity = activityService.findById(activityId);
        ActivityMaterial material = activityService.findMaterialByActivity(activityId);
        if (activity != null && !StringUtils.isEmpty(material.getJlbg())) {
            HttpHeaders headers = new HttpHeaders();
            headers.setContentType(MediaType.APPLICATION_OCTET_STREAM);
            String stuffPath = ConfigUtil.getValue("stuff-path") + material.getJlbg();
            String fileName = material.getJlbg();
            String fileType = fileName.substring(fileName.lastIndexOf("."), fileName.length());
            File file = new File(stuffPath);
            if (file != null) {
                String customFileName = new String((activity.getFullName() + "监理报告" + fileType).getBytes("GBK"), "iso-8859-1");
                headers.setContentDispositionFormData("attachment", customFileName);
                try {
                    return new ResponseEntity<byte[]>(FileUtils.readFileToByteArray(file), headers, HttpStatus.OK);
                } catch (IOException e) {
                    log.error(e.getMessage());
                    e.printStackTrace();
                    return null;
                }
            }
        }
        return null;
    }


    /*初审*/
    @RequestMapping("primary/save")
    @OperLog(menuName = "许可活动",operateType = "#primary_approve",operateTypeMethod="transferCS",operateObj = "#approve.activityId")
//    @AuditLogAn(operateType = DictConst.OP_UPDATE,menuName = MenuConst.HDGL_XKHD_CS)
    public @ResponseBody AjaxResult primarySave(Approve approve, String[] checkDates, String[] situations, HttpServletRequest request) throws ParseException {
        User user = super.getCurrentUser(request);

        String primary_approve = request.getParameter("primary_approve");
        String rejectContent = request.getParameter("rejectContent");

        String[] checkIndexs = request.getParameterValues("checkIndexs");

        int loop = checkDates.length;
        loop = situations.length > loop ? situations.length : loop;
        for (int i = 0; i < loop; i++) {
            ApproveDetail detail = new ApproveDetail();
            if (checkDates.length > i) {
                String checkDate = checkDates[i];
                if (Strings.isNullOrEmpty(checkDate)) {
                    detail.setCheckDate(new Date());
                } else {
                    Date cd = BcxinDateUtil.systemDate.parse(checkDate);
                    detail.setCheckDate(cd);
                }
            } else {
                detail.setCheckDate(new Date());
            }
            if (situations.length > i) {
                detail.setSituation(situations[i]);
            }
            detail.setAddTime(new Date());
            detail.setUpdateTime(new Date());
            detail.setUpdater(user.getRealName());

            String[] imgPaths = request.getParameterValues("copy_imgPaths" + checkIndexs[i]);
            StringBuffer imgPathBuffer = new StringBuffer();
            if (imgPaths != null) {
                for (String imgPath : imgPaths) {
                    if (imgPathBuffer.length() > 0) {
                        imgPathBuffer.append("&&" + imgPath);
                    } else {
                        imgPathBuffer.append(imgPath);
                    }
                }
                detail.setImgPath(imgPathBuffer.toString());
            }
            approve.getDetails().add(detail);
        }
        //未填写检查记录，默认添加一条空数据
        if (loop <= 0) {
            ApproveDetail detail = new ApproveDetail();
            detail.setAddTime(new Date());
            detail.setUpdateTime(new Date());
            approve.getDetails().add(detail);
        }

        return workflowService.primaryApprove(user,approve, primary_approve, rejectContent);
    }


    /**
     * 等级评定
     * @param request
     * @return
     * @throws ParseException
     */
    @RequestMapping("grade/feedback/save")
    @OperLog(menuName = "许可活动",operateType = "#grade_approve",operateTypeMethod="transferCS",operateObj = "#approve.activityId")
//    @AuditLogAn(operateType = DictConst.OP_UPDATE,menuName = MenuConst.HDGL_XKHD_DJPD)
    public @ResponseBody AjaxResult gradeFeedbackSave(HttpServletRequest request) {
        AjaxResult result = new AjaxResult();
        User user = super.getCurrentUser(request);
        Map<String,String> params = WebUtil.getParameterMap(request);
        workflowService.gradeFeedbackApprove(user,params);
        result.setSuccessful(true);
        return result;
    }

    /**
     * 受理补充材料
     * @param request
     * @return
     * @throws ParseException
     */
    @RequestMapping("shouli/feedback/save")
    @AuditLogAn(operateType = DictConst.OP_UPDATE,menuName = MenuConst.HDGL_XKHD_SL)
    public @ResponseBody AjaxResult shouliFeedbackSave(HttpServletRequest request) {
        AjaxResult result = new AjaxResult();
        User user = super.getCurrentUser(request);
        Map<String,String> params = WebUtil.getParameterMap(request);
        workflowService.shouliFeedbackApprove(user,params);
        result.setSuccessful(true);
        return result;
    }

    /**
     * 等级评定
     * @param request
     * @return
     * @throws ParseException
     */
    @RequestMapping("grade/save")
    @OperLog(menuName = "许可活动",operateType = "#grade_approve",operateTypeMethod="transferCS",operateObj = "#approve.activityId")
//    @AuditLogAn(operateType = DictConst.OP_UPDATE,menuName = MenuConst.HDGL_XKHD_DJPD)
    public @ResponseBody AjaxResult gradeSave(HttpServletRequest request) throws Exception{
        User user = super.getCurrentUser(request);
        Map<String,String> params = WebUtil.getParameterMap(request);
        return workflowService.gradeApprove(user,params);
    }


    /**
     * 承办方等级评定重新评定申请
     * @param request
     * @return
     * @throws ParseException
     */
    @RequestMapping("contractor/re/grade/save")
    @OperLog(menuName = "承办方重新评定安全管理等级申请",operateType = "#grade_approve",operateTypeMethod="transferCS",operateObj = "#approve.activityId")
//    @AuditLogAn(operateType = DictConst.OP_UPDATE,menuName = MenuConst.HDGL_XKHD_DJPD_CP)
    public @ResponseBody AjaxResult contractorReGradeSave(HttpServletRequest request){
        User user = super.getCurrentUser(request);
        Map<String,String> params = WebUtil.getParameterMap(request);
        return workflowService.contractorReGradeSave(user,params);
    }


    /**
     * 公安等级评定重新评定
     * @param request
     * @return
     * @throws ParseException
     */
    @RequestMapping("police/re/grade/save")
    @AuditLogAn(operateType = DictConst.OP_UPDATE,menuName = MenuConst.HDGL_XKHD_DJPD_CP)
    public @ResponseBody AjaxResult policeReGradeSave(HttpServletRequest request) throws Exception{
        AjaxResult result = new AjaxResult();
        User user = super.getCurrentUser(request);
        Map<String,String> params = WebUtil.getParameterMap(request);
        workflowService.policeReGradeSave(user,params);
        result.setSuccessful(true);
        return result;
    }


    /**
     * 备案活动打回
     * @param request
     * @return
     * @throws ParseException
     */
    @RequestMapping("/rejectBackUpAct")
    @OperLog(menuName = "备案活动",operateType = "退回",operateObj = "#activityId")
//    @AuditLogAn(operateType = DictConst.OP_UPDATE,menuName = MenuConst.HDGL_XKHD_DH)
    public @ResponseBody AjaxResult rejectBackUpAct(HttpServletRequest request) throws ParseException {
        AjaxResult result = new AjaxResult();
        try {
            User user = super.getCurrentUser(request);
            String rejectContent = request.getParameter("rejectContent");
            String activityId = request.getParameter("activityId");
            workflowService.rejectBackUpAct(user, activityId, rejectContent);
            result.setSuccessful(true);
        }catch (Exception e){
            e.printStackTrace();
            result.setSuccessful(false);
        }
        return result;
    }



    /*受理*/

    @RequestMapping("sl/save")
//    @AuditLogAn(operateType = DictConst.OP_UPDATE,menuName = MenuConst.HDGL_XKHD_SL)
    @OperLog(menuName = "许可活动",operateType = "#sl_approve",operateTypeMethod="transferSL",operateObj = "#sl_activityId")
    public @ResponseBody AjaxResult preliminarySave(HttpServletRequest request) throws ParseException {
        User user = super.getCurrentUser(request);
        String approveStatus = request.getParameter("sl_approve");
        String bslContent = request.getParameter("bslContent");
        String activityId = request.getParameter("sl_activityId");

        return workflowService.slApprove(user,approveStatus, bslContent,activityId);
    }

    /**
     * 上传文件
     * @param file
     * @return
     */
    @RequestMapping("uploadFile")
    public @ResponseBody AjaxResult uploadFile(MultipartFile file) throws Exception {
        AjaxResult result = new AjaxResult();
        try {
            Date now = new Date();
            String stuffPath = ConfigUtil.getValue("stuff-path");
            //String uploadFileName = file.getOriginalFilename().split("\\.")[0]; //上传文件名
            String materialFileType = file.getOriginalFilename().split("\\.")[1]; //文件类型
            String fileName = now.getTime() +"."+ materialFileType;
            String dirDate = BcxinDateUtil.systemDate.format(now);
            File dir = new File(stuffPath + dirDate);
            if(!dir.exists()) {
                dir.mkdirs();
            }
            String key = stuffPath + dirDate + "/" + fileName;
            String url = GlobalConst.PACK_DOWNLOAD + key;
            String targetPath = stuffPath + dirDate + "/" + fileName;
            File targetFile = new File(targetPath);
            file.transferTo(targetFile);

            result.setSuccessful(true);
            result.setObj(url);
        } catch(Exception e) {
            throw e;
        }
        return result;
    }

    @RequestMapping("findApproveDetail/{approveId}")
    public @ResponseBody List<ApproveDetail> findApproveDetail(@PathVariable("approveId") Long approveId, HttpServletRequest request) {
        return approveService.findApproveDetail(approveId);
    }

    @RequestMapping("findApprove/{approveId}")
    public @ResponseBody Approve findApprove(@PathVariable("approveId") Long approveId, HttpServletRequest request) {
        return approveService.findApproveById(approveId);
    }

    @RequestMapping("approveTable/{activityId}")
    public void approveTable(@PathVariable("activityId") Long activityId, HttpServletRequest request) {
        Activity activity = activityService.findById(activityId);
        approveFileService.generateaqxkspb(activity);
    }

    @RequestMapping("getContractorList/{activityId}")
    public @ResponseBody List<ActivityContractor> getContractorList(@PathVariable("activityId") Long activityId, HttpServletRequest request) {
        return activityContractorService.selectByActivityId(activityId);
    }


    @RequestMapping("activityDetail/{activityId}")
//    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.HDGL_XKHD_HDXQ)
    public ModelAndView activityDetail(@PathVariable("activityId") Long activityId, HttpServletRequest request) {
        ModelAndView view = new ModelAndView("/activity/dialog/detail");
        Activity activity = activityService.findById(activityId);

        List<ApproveHistory> historyList = approveService.findHistoryByActivityId(activityId);
        historyList.forEach(approveHistory -> {
            if(approveHistory.getApproveId() != null) {
                approveHistory.setDetailList(approveService.findApproveDetail(approveHistory.getApproveId()));
            }
        });

        view.addObject("access_token",request.getParameter("access_token") );
        view.addObject("activity",activity);
        view.addObject("material",activityService.findMaterialByActivity(activityId));
        view.addObject("contractors", activityContractorService.selectByActivityId(activityId));
        view.addObject("activityType", ActivityUtil.getTypeByCode(activity.getTypeCode()));
        view.addObject("historyList",historyList);
        view.addObject("approveTypeMap",ApproveUtil.getApproveType());
        return view;
    }

    /**
     * 转交活动
     * @param request
     * @return
     */
//    @AuditLogAn(operateType = DictConst.OP_SELECT,menuName = MenuConst.HDGL_XKHD_ZJ)
    @OperLog(menuName = "许可活动",operateType = "#type",operateObj = "#activityId")
    @RequestMapping("/transferAct")
    public @ResponseBody AjaxResult transferAct(HttpServletRequest request){
        AjaxResult result = new AjaxResult();
        try{
            User user = super.getCurrentUser(request);
            String activityId=request.getParameter("activityId");
            String province=request.getParameter("province");
            String city=request.getParameter("city");
            String area=request.getParameter("area");
            String transferContent=request.getParameter("transferContent");
            workflowService.transferAct(user,activityId,province,city,area,transferContent);
            result.setSuccessful(true);
        }catch (Exception e){
            result.setMsg(e.getMessage());
            result.setSuccessful(false);
        }
        return result;
    }

}
