package com.bcxin.sp.work.controller.third.shanma;

import com.bcxin.sp.work.controller.sys.BaseController;
import com.bcxin.sp.work.entity.dto.AjaxResult;
import com.bcxin.sp.work.service.third.shanma.CommunicateService;
import com.bcxin.sp.work.util.StringUtil;
import com.bcxin.sp.work.util.zj.JwtUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * 审批管理
 *
 * @author 罗鹏
 */
@Controller
@RequestMapping("/third/shanma")
@Slf4j
public class ShanmaCommunicateController extends BaseController {

    @Resource
    private CommunicateService communicateService;


    /**
     * <b> 保存摄像头信息 </b>
     *
     * @author ZXF
     * @create 2020/02/27 0027 10:40
     * @version
     * @注意事项 </b>
     */
    @RequestMapping("camera")
    @ResponseBody
    public AjaxResult camera(HttpServletRequest request) {
        String token = request.getParameter("token");
        if (StringUtil.isEmpty(token)) {
            return AjaxResult.fail("token不能为空！");
        }
        try {
            Map map = JwtUtil.parseMap(token);
            if (map == null) {
                return AjaxResult.fail("未携带有效数据信息！");
            }
            return communicateService.saveCamera(map);
        } catch (Exception e) {
            return AjaxResult.fail("无效token！");
        }
    }

    /**
     * <b> 保存摄像头视频分析数据 </b>
     *
     * @author ZXF
     * @create 2020/02/27 0027 10:40
     * @version
     * @注意事项 </b>
     */
    @RequestMapping("camera/analyze")
    @ResponseBody
    public AjaxResult analyze(HttpServletRequest request) {
        String token = request.getParameter("token");
        if (StringUtil.isEmpty(token)) {
            return AjaxResult.fail("token不能为空！");
        }
        try {
            Map map = JwtUtil.parseMap(token);
            if (map == null) {
                return AjaxResult.fail("未携带有效数据信息！");
            }
            return communicateService.saveAnalyze(map);
        } catch (Exception e) {
            return AjaxResult.fail("无效token！");
        }
    }

    /**
     * <b> 保存摄像头视频分析数据 </b>
     *
     * @author ZXF
     * @create 2020/02/27 0027 10:40
     * @version
     * @注意事项 </b>
     */
    @RequestMapping("camera/analyze/total")
    @ResponseBody
    public AjaxResult analyzeTotal(HttpServletRequest request) {
        String token = request.getParameter("token");
        if (StringUtil.isEmpty(token)) {
            return AjaxResult.fail("token不能为空！");
        }
        try {
            Map map = JwtUtil.parseMap(token);
            if (map == null) {
                return AjaxResult.fail("未携带有效数据信息！");
            }
            return communicateService.saveAnalyzeTotal(map);
        } catch (Exception e) {
            return AjaxResult.fail("无效token！");
        }
    }

}
