package com.bcxin.sp.work.dao.activity.approve;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.bcxin.sp.work.entity.domain.activity.approve.FileNumber;
import com.bcxin.sp.work.entity.dto.FileNumberDTO;
import com.bcxin.sp.work.entity.dto.SearchDto;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;


/**
 * @author 张建华
 */
@Repository
public interface FileNumberMapper extends BaseMapper<FileNumber> {


    /**
     * 根据地区查询文件编号
     *
     * @param city
     * @param area
     * @param approveLevel
     * @return
     */
    List<FileNumber> selectFileNumber(@Param("city")String city, @Param("area") String area, @Param("approveLevel") String approveLevel);

    /**
     * 文件编号列表
     *
     * @param dto
     * @return
     */
    List<FileNumberDTO> listFileNumber(SearchDto<FileNumberDTO> dto);

    List listFileNumberOfMap(FileNumberDTO dto);

    /**
     * count
     *
     * @param dto
     * @return
     */
    long countFileNumber(SearchDto<FileNumberDTO> dto);
}
