package com.bcxin.sp.work.dao.base;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.baomidou.mybatisplus.plugins.Page;
import com.bcxin.sp.work.entity.domain.base.Venue;
import com.bcxin.sp.work.entity.dto.SearchDto;
import com.bcxin.sp.work.entity.dto.VenueDTO;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

@Repository
public interface VenueMapper extends BaseMapper<Venue> {

	List<Map> findVenueListByActivityId(@Param("activityId") Long activityId);

	List<Map> findCggdListData(SearchDto<VenueDTO> dto);
	Long findCggdListDataCnt(SearchDto<VenueDTO> dto);

	Map getVenueByIdForOne(@Param("activityId") Long activityId);


	/**
	 * 自动生成的几个方法
	 * @param id
	 * @return
	 */
	int deleteByPrimaryKey(Long id);

	int insertCommon(Venue record);

	int insertSelective(Venue record);

	Venue selectByPrimaryKey(Long id);

	int updateByPrimaryKeySelective(Venue record);

	int updateByPrimaryKey(Venue record);

	/**
	 * 查出所有场馆--分页
	 * @param page
	 * @param searchDTO
	 * @return
	 */
	List<Venue> findAllPage(Page page, SearchDto<VenueDTO> searchDTO);

	//查出所有场馆-不分页
	List<Venue> findAll();

}
