package com.bcxin.sp.work.dao.log;
import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.bcxin.sp.work.entity.domain.log.AuditLog;
import com.bcxin.sp.work.entity.domain.log.OperateLog;
import com.bcxin.sp.work.entity.dto.OperateLogSearchDTO;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface AuditLogMapper extends BaseMapper<AuditLog> {
    /**
     * 查出需要同步成功，或者（同步失败 +未同步）的记录
     * @param limits
     * @return
     */
    List<AuditLog> findNeedSyncLog(@Param("limits")Integer limits);

    /**
     * 批量更新指定id数组的同步状态
     * @param updatedSyncStatus
     * @param idList
     * @return
     */
    int updateSyncStatusById(@Param("updatedSyncStatus")String updatedSyncStatus,@Param("idList")List<Long> idList);


    List<AuditLog> searchLog(OperateLogSearchDTO dto);

    long searchLogCount(OperateLogSearchDTO dto);



}
