package com.bcxin.sp.work.dao.user;

import com.baomidou.mybatisplus.mapper.BaseMapper;
import com.bcxin.sp.work.entity.domain.activity.base.Activity;
import com.bcxin.sp.work.entity.domain.user.User;
import com.bcxin.sp.work.entity.dto.SearchDto;
import com.bcxin.sp.work.entity.dto.UserSummaryDto;
import com.bcxin.sp.work.entity.dto.UserSummarySearchDto;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface UserMapper extends BaseMapper<User> {

    List<User> findUser(SearchDto searchDto);

    long findCountOfUser(SearchDto searchDto);

    List<User> findByRegionAndRole(@Param("province")String province,@Param("city")String city,
                                   @Param("area")String area,@Param("role") String role);

    User findUserById(@Param("userId") Long userId);

    User findUserByUserName(@Param("userName") String userName);

    User findUserByPoliceNumber(@Param("policeNumber") String policeNumber);

    /**
     * 查询一级审批人员
     *
     * @param level
     * @param activityId
     * @return
     */
    List<User> findApproveUser(@Param("level") String level, @Param("activityId") Long activityId);

    List<User> findAllApproveUser(@Param("level") String level,@Param("activityId") Long activityId);

    /**
     * 获得第一级的审批用户
     * @param activityId
     * @return
     */
    List<User> findFirstApproveUser(@Param("activityId") Long activityId);

    /**
     * 获得指定的的审批用户
     * @param activityId
     * @return
     */
    User findAppointApproveUser(@Param("activityId") Long activityId);

    /**
     * 人员配置统计
     * @param searchDto
     * @return
     */
    List<UserSummaryDto> summarySearch(UserSummarySearchDto searchDto);

    Long summarySearchCount(UserSummarySearchDto searchDto);

    List<User> findAdminUserList(User user);

    User selectUserByApprove(@Param("activityId") Long activityId);

    /**
     * 可以查看备案活动的人员（当前地区）
     * @param activity
     * @return
     */
    List<User> listAdminAndApproveOfBackUp(Activity activity);

    String selectApproveLevelByUserId(@Param("userId")Long userId);
}
