package com.bcxin.sp.work.entity.domain.activity.approve;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 审批历史表，记录审批的时间节点等信息
 */
@Data
@TableName("sp_approve_history")
public class ApproveHistory extends Model<ApproveHistory> {

	private static final long serialVersionUID = -7088672083348697781L;

	@TableId(type = IdType.AUTO)
	private Long id;
	private Long activityId;
	private Long approveId;

	@JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
	private Date addTime = new Date();

	/**
	 * 是否重新申请
	 */
	private String isReset;

	/**
	 * 是否该审批类型的审批流程已结束
	 */
	private String finish;

	/*
	 "10":初审
	 "20":受理
	 "30":审批
	 "40":转交
	*/
	private String approveType;

	/**
	 * 用户
	 */
	private String userName;

	/**
	 * 审批意见
	 */
	private String opinion;

	/**
	 * 审批步骤描述
	 */
	private String content;

	/**
	 * 审批状态
	 */
	private String approve;

	/**
	 * 耗时
	 */
	private String elapsed;

	/**
	 * 备注
	 */
	private String remark;

	/**
	 * 审批检查详情
	 */
	@TableField(exist = false)
	private List<ApproveDetail> detailList = new ArrayList<ApproveDetail>();

	@Override
	protected Serializable pkVal() {
		return this.id;
	}
}
