package com.bcxin.sp.work.entity.domain.activity.expand;

import com.alibaba.fastjson.annotation.JSONField;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * 风险评估
 */
@Data
@TableName("sp_activity_assessment")
public class ActivityAssessment extends Model<ActivityAssessment> {

    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.AUTO)
    @JsonSerialize(using= ToStringSerializer.class)
    private Long activityAssessmentId;
    private Long pssId;//pss同步过来的id
    /**
     * 风评机构名称
     */
    private String fullName;
    /**
     * 初稿撰写
     */
    private String draft;
    /**
     * 审核报告人员
     */
    private String approve;
    /**
     * 专家评估
     */
    private String expert;
    /**
     * 复核组长
     */
    private String leader;
    /**
     * 风险评估报告
     */
    private String reportUrl;

    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private Date addTime = new Date();
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime = new Date();

    /**
     * 服务商类型
     */
    private String assessmentType;
    /**
     * 联系人
     */
    private String contact;
    /**
     * 联系电话
     */
    private String phone;

    private String province;
    private String city;
    private String area;
    /**
     * 省市区名称（用于前端，表中不存在该字段）
     */
    @TableField(exist = false)
    private String pcaName;
    /**
     * 企业地址
     */
    private String address;
    /**
     * 组织代码
     */
    private String organizationCode;
    /**
     * 营业执照图片地址
     */
    private String orgUrl;
    /**
     * 管理员手机
     */
    private String adminTel;
    /**
     * 邮箱
     */
    private String email;
    /**
     * 修改人
     */
    private String updater;

    /**
     * 是否冻结
     */
    private int isFreeze;
    /**
     * 是否需要同步：0.否，1是
     */
    private int isSync;

    /**
     * 审批状态 1.通过，2.不通过，其它.审批中
     */
    private int approveStatus;
    /**
     * 申请时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JSONField(format="yyyy-MM-dd HH:mm")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private Date applyTime;

    @Override
    protected Serializable pkVal() {
        return this.activityAssessmentId;
    }

}
