package com.bcxin.sp.work.entity.domain.activity.expand;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 活动-临建项
 */
@Data
@TableName("sp_activity_build_item")
public class ActivityBuildItem extends Model<ActivityBuildItem> {

    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.AUTO)
    @JsonSerialize(using= ToStringSerializer.class)
    private Long activityBuildItemId;

    /**
     * 活动-临建公司Id
     */
    @JsonSerialize(using= ToStringSerializer.class)
    private Long activityBuildId;

    /**
     * 临建编号
     */
    private String itemNo;

    /**
     * 项目名称
     */
    private String itemName;

    /**
     * 项目英文名
     */
    private String itemEN;

    /**
     * 临建类型
     */
    private String itemType;

    /**
     * 面积
     */
    private String area;

    /**
     * 审核状态
     */
    private String approveStatus;

    /**
     * 项目资料
     */
    private String itemUrl;


    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private Date addTime = new Date();

    @Override
    protected Serializable pkVal() {
        return this.activityBuildId;
    }

}
