package com.bcxin.sp.work.entity.domain.activity.expand;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 存放活动的详细信息，不重要的活动信息可以放在这里
 */
@Data
@TableName("sp_activity_detail")
public class ActivityDetail extends Model<ActivityDetail> {

    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.AUTO)
    private Long id;
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private Date addTime = new Date();
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime = new Date();

    /**
     * 活动id
     */
    private Long activityId;

    /**
     * 活动内容
     */
    private String hdnr;
    /**
     * 保安公司
     */
    private String bags;
    /**
     * 保安人员总数
     */
    private String baryzs;
    /**
     * 场地容量
     */
    private String cdrl;


    /**
     * 拟制作证件数量
     */
    private String nzjs;

    /**
     * 场地面积
     */
    private String cdmj;

    /**
     * 现场参与总人数
     */
    private String xccys;

    /**
     * 志愿者总人数
     */
    private String zyzzs;

    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
