package com.bcxin.sp.work.entity.domain.activity.history;

import com.alibaba.fastjson.annotation.JSONField;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * 数据补录历史数据
 * @author 罗鹏
 */
@Data
@TableName("SP_ACTIVITY_HISTORY")
public class ActivityHistory extends Model<ActivityHistory> {

    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.AUTO)
    private Long id;
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private Date addTime = new Date();
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime = new Date();

    /**
     * 录入人员
     */
    private Long userId;

    /**
     * 活动名称
     */
    private String fullName;

    /**
     * 活动编码
     */
    private String activityNo;

    /**
     * 活动类型
     */
    private String activityType;
    private String province;
    private String city;
    private String area;

    /**
     * 活动地点
     */
    private String address;

    /**
     * 活动期间单日最大参加人数
     */
    private String peakNumber;

    /**
     * 活动开始时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JSONField(format="yyyy-MM-dd HH:mm")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private Date startDate;

    /**
     * 活动截止时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JSONField(format="yyyy-MM-dd HH:mm")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private Date endDate;

    /**
     * 承办方
     */
    private String sponsor;
    /**
     * 承办方注册地址
     */
    private String sponsorAddress;
    /**
     * 主办方
     */
    private String organizer;

    /**
     * 评估机构
     */
    private String assessment;

    /**
     * 场地类型
     */
    private String addressType;

    /**
     * 评估报告
     */
    private String pgbg;

    /**
     * 报备材料
     */
    private String bbcl;

    /**
     * approve 许可活动
     * report 报备活动
     */
    private String activityChannel;
    /**
     * 逻辑删除，默认为0
     */
    private String logicDel = "0";
    /**
     * 活动坐标
     */
    private String coordinate;
    /**
     * 活动简介
     */
    private String introduce;
    /**
     * 上报时间（浙江用）
     */
    private String reportTime;

    @Override
    protected Serializable pkVal() {
        return this.id;
    }


}
