package com.bcxin.sp.work.entity.domain.activity.other;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 活动，与飞行器关联
 */
@Data
@TableName("sp_activity_Aircraft")
public class ActivityAircraft extends Model<ActivityAircraft> {

	private static final long serialVersionUID = 7064937058904767154L;

	@TableId(type = IdType.INPUT)
	@JsonSerialize(using = ToStringSerializer.class)
	private Long activityAircraftId;

	/**
	 * 活动id
	 */
	@JsonSerialize(using = ToStringSerializer.class)
	private Long activityId;

	/**
	 * 飞行器id
	 */
	@JsonSerialize(using = ToStringSerializer.class)
	private Long aircraftId;

	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	private Date createOn;


	@Override
	protected Serializable pkVal() {
		return this.activityAircraftId;
	}
}
