package com.bcxin.sp.work.entity.domain.activity.person;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 活动人员，参会人员,背审信息
 */
@Data
@TableName("sp_activity_person_back")
public class ActivityPersonBack extends Model<ActivityPersonBack> {

	private static final long serialVersionUID = 7064937058904767154L;

	@TableId(type = IdType.INPUT)
	private Long activityPersonBackId;

	/**
	 * 人员id
	 */
	private Long activityPersonId;

	/**
	 * 职业
	 */
	private String job;

	/**
	 * 服务处所
	 */
	private String company;

	/**
	 * 地址
	 */
	private String address;

	/**
	 * 电话
	 */
	private String mobile;

	/**
	 * 背审状态
	 */
	private String backStatus;

	/**
	 * 是否前科人员
	 */
	private String isQkPerson;

	/**
	 * 是否在逃人员
	 */
	private String isZtPerson;

	/**
	 * 是否极端分子
	 */
	private String isJdPerson;

	/**
     * 是否非访人员
	 */
	private String isFfPerson;

	/**
     * 是否涉恐人员
	 */
	private String isSkPerson;

	/**
     * 是否吸毒人员
	 */
	private String isXdPerson;

	/**
	 * 是否精神病人
	 */
	private String isJsbr;

	/**
	 * 重点人员编号
	 */
	private String keyPersonNo;

	/**
	 * 案件编号
	 */
	private String keyPersonCaseNo;

	/**
	 * 审查时间
	 */
	@JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
	private Date approveDate;


	@Override
	protected Serializable pkVal() {
		return this.activityPersonId;
	}
}
