package com.bcxin.sp.work.entity.domain.activity.person;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.util.Date;

/**
 * 监控人员出行数据
 * 民航
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName("sp_activity_person_Monitor_air_track")
public class ActivityPersonMonitorAirTrack extends Model<ActivityPersonMonitorAirTrack> {

	private static final long serialVersionUID = 7064937058904767154L;

	@TableId(type = IdType.INPUT)
	@JsonSerialize(using = ToStringSerializer.class)
	private Long activityPersonMonitorAirTrack;

	/**
	 * 人员id
	 */
	@JsonSerialize(using = ToStringSerializer.class)
	private Long activityPersonId;

	/**
     * 信息类型
	 */
	private String trackType;

	/**
	 * 航班号
	 */
	private String flightNo;

	/**
	 * 座位号
	 */
	private String siteNo;

	/**
	 * 出发机场
	 */
	private String depart;

	/**
	 * 出发日期
	 */
	private String departDate;

	/**
	 * 到达机场
	 */
	private String arrive;

	/**
	 * 到达日期
	 */
	private String arriveDate;

	/**
	 * 采集时间
	 */
	private String collectDate;

	/**
	 * 信息入库时间
	 */
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	private Date createOn;

	@Override
	protected Serializable pkVal() {
		return this.activityPersonId;
	}

	/**
	 * 非数据库字段
	 */
	private String  arriveTime;
	private String  departTime;

}
