package com.bcxin.sp.work.entity.domain.activity.person;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 监控人员出行数据
 * 旅馆住宿
 * @author
 */
@Data
@TableName("sp_activity_person_Monitor_hotel_track")
public class ActivityPersonMonitorHotelTrack extends Model<ActivityPersonMonitorHotelTrack> {

	private static final long serialVersionUID = 7064937058904767154L;

	@TableId(type = IdType.INPUT)
	@JsonSerialize(using= ToStringSerializer.class)
	private Long activityPersonMonitorHotelTrackId;

	/**
	 * 人员id
	 */
	@JsonSerialize(using= ToStringSerializer.class)
	private Long activityPersonId;

	/**
     * 信息类型
	 */
	private String trackType;

	/**
	 * 编号
	 */
	private String hotelNo;

	/**
	 * 旅馆名称
	 */
	private String hotelName;

	/**
	 * 房间号
	 */
	private String roomNo;

	/**
	 * 入住时间
	 */
	private String startDate;

	/**
	 * 退房时间
	 */
	private String endDate;

	/**
	 * 采集时间
	 */
	private String collectDate;

	/**
	 * 信息入库时间
	 */
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	private Date createOn;

	@Override
	protected Serializable pkVal() {
		return this.activityPersonMonitorHotelTrackId;
	}
}
