package com.bcxin.sp.work.entity.domain.activity.person;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 监控人员出行数据
 * 公路
 */
@Data
@TableName("sp_activity_person_Monitor_road_track")
public class ActivityPersonMonitorRoadTrack extends Model<ActivityPersonMonitorRoadTrack> {

	private static final long serialVersionUID = 7064937058904767154L;

	@TableId(type = IdType.INPUT)
	@JsonSerialize(using= ToStringSerializer.class)
	private Long activityPersonMonitorRoadTrackId;

	/**
	 * 人员id
	 */
	@JsonSerialize(using= ToStringSerializer.class)
	private Long activityPersonId;

	/**
     * 信息类型
	 */
	private String trackType;

	/**
	 * 客运站
	 */
	private String station;

	/**
	 * 客运编号
	 */
	private String carNo;

	/**
	 * 车厢座位号
	 */
	private String siteNo;

	/**
	 * 出发车站
	 */
	private String depart;

	/**
	 * 出发日期
	 */
	private String departDate;

	/**
	 * 到达车展
	 */
	private String arrive;

	/**
	 * 到达日期
	 */
	private String arriveDate;

	/**
	 * 采集时间
	 */
	private String collectDate;

	/**
	 * 信息入库时间
	 */
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	private Date createOn;

	@Override
	protected Serializable pkVal() {
		return this.activityPersonMonitorRoadTrackId;
	}
	/**
	 * 非数据库字段
	 */
	private String arriveTime;
	private String  departTime;
}
