package com.bcxin.sp.work.entity.domain.activity.security;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import lombok.Data;

import java.io.Serializable;

/**
 * 安保人员（保安和警察共用）
 */
@Data
@TableName("sp_security_person")
public class SecurityPerson extends Model<SecurityPerson> {

	private static final long serialVersionUID = 7064937058904767154L;

	@TableId(type = IdType.INPUT)
	private Long securityPersonId;

	/**
	 * 人员类型
	 * 安保人员
	 * 警力人员
	 */
	private String personType;

	/**
	 * 姓名
	 */
	private String fullName;

	/**
	 * 曾用名
	 */
	private String usedName;

	/**
	 * 性别代码
	 */
	private String sex;

	/**
	 * 照片
	 */
	private String avatar;

	/**
	 * 电话
	 */
	private String mobile;

	/**
	 * 单位名称
 	 */
	private String comName;

	/**
	 * 常用证件代码
	 */
	private String idCardType;

	/**
	 * 证件号码
	 */
	private String idCardNo;

	/**
	 * 国籍代码
	 */
	private String country;

	/**
	 * 民族代码
	 */
	private String nation;

	/**
	 * 籍贯
	 */
	private String nativeAddress;

	/**
	 * 国家（地区）
	 * 	省市县（区）
	 * 	区划内详细地址
	 */
	private String province;

	private String city;

	private String area;

	private String address;

	/**
	 * 实际居住地
	 */
	private String actualAddress;

	/**
	 * 保安证件
	 */
	private String securityCertUrl;

	/**
	 * 证件号码
	 */
	private String securityCertNo;

	/**
	 * 有效期截止日期
	 */
	private String securityCertEndDate;

	/**
	 * 学历代码
	 */
	private String education;

	/**
	 * 特殊身份
	 */
	private String specialIdentity;

	/**
	 * 出生日期
	 */
	private String birthday;

	/**
	 * 婚姻状况代码
	 */
	private String marry;

	/**
	 * 宗教信仰代码
	 */
	private String religion;

	/**
	 * 政治面貌代码
	 */
	private String politics;


	/**
	 * 警员编号
	 */
	private String policeCode;
	/**
	 * 警龄
	 */
	private String policeYear;
	/**
	 * 警衔与文职级别代码
	 */
	private String policeTitle;

	//		配偶
	//姓名
	//		公民身份证号
	//联系电话
	//		更新时间

	/**
	 * 人脸识别状态
	 */
	private String faceStatus;

	@Override
	protected Serializable pkVal() {
		return this.securityPersonId;
	}
}
