package com.bcxin.sp.work.entity.domain.activity.security;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 安保任务-保安-轨迹（保安）
 */
@Data
@TableName("sp_activity_security_task_person_track")
public class SecurityTaskPersonTrack extends Model<SecurityTaskPersonTrack> {

	private static final long serialVersionUID = 7064937058904767154L;

	@TableId(type = IdType.AUTO)
	private Long securityTaskPersonTrackId;

	/**
     * 安保路线id
	 */
	private Long securityTaskPersonLineId;

	/**
	 * 保安人员
	 */
	private Long securityPersonId;

	/**
	 * 巡逻时间
	 */
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	private Date trackTime;

	/**
	 * 巡逻地址经度	作为GIS打点数据
	 */
	private String longitude;

	/**
	 * 巡逻地址纬度	作为GIS打点数据
	 */
	private String latitude;

	@Override
	protected Serializable pkVal() {
		return this.securityTaskPersonTrackId;
	}

}
