package com.bcxin.sp.work.entity.domain.activity.traffic;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 活动，重点车辆信息
 */
@Data
@TableName("sp_activity_car")
public class ActivityCar extends Model<ActivityCar> {

	private static final long serialVersionUID = 7064937058904767154L;

	@TableId(type = IdType.INPUT)
	private Long activityCarId;

	/**
	 * 活动id
	 */
	private Long activityId;

	/**
	 * 汽车id
	 */
	private Long carId;

	/**
	 * 车辆编号
	 */
	private String carNo;

	/**
	 * 出发地
	 */
	private String depart;

	/**
	 * 目的地
	 */
	private String arrive;

	/**
	 * 出发时间
	 */
	private String startDate;

	private Date createOn;


	/**
	 * 性别
	 */
	private String sex;

	/**
	 * 身份证号
	 */
	private String idCardNo;

	/**
	 * 人员照片
	 */
	private String avatar;

	/**
	 * 姓名
	 */
	private String fullName;

	/**
	 * 公民身份证号码
	 */
	private Integer age;

	/**
	 * 学历
	 */
	private String education;

	/**
	 * 民族
	 */
	private String nation;

	/**
	 * 婚姻状态
	 */
	private String marry;

	/**
	 * 籍贯
	 */
	private String birthplace;

	/**
	 * 行政区划代码
	 */
	private String region;

	/**
	 * 区划内详细地址
	 */
	private String address;

	/**
	 * 名称
	 */
	private String name;

	/**
	 * 电子文件位置
	 */
	private String fileLocation;

	/**
	 * 政治面貌
	 */
	private String politics;

	/**
	 * 车辆危爆品信息
	 */
	private String carDanger;

	@Override
	protected Serializable pkVal() {
		return this.activityCarId;
	}
}
