package com.bcxin.sp.work.entity.domain.activity.traffic;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 活动，重点车辆信息-位置信息
 */
@Data
@TableName("sp_activity_car_track")
public class ActivityCarTrack extends Model<ActivityCarTrack> {

	private static final long serialVersionUID = 7064937058904767154L;

	@TableId(type = IdType.INPUT)
	private Long activityCarTrackId;


	private Long activityCarId;

	/**
	 * 地址经度	作为GIS打点数据
	 */
	private String longitude;

	/**
	 * 地址纬度	作为GIS打点数据
	 */
	private String latitude;

	@JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
	private Date createOn;


	@Override
	protected Serializable pkVal() {
		return this.activityCarTrackId;
	}
}
