package com.bcxin.sp.work.entity.domain.activity.traffic;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 活动，路况信息
 */
@Data
@TableName("sp_activity_traffic")
public class ActivityTraffic extends Model<ActivityTraffic> {

	private static final long serialVersionUID = 7064937058904767154L;

	@TableId(type = IdType.INPUT)
	private Long activityTrafficId;

	/**
	 * 活动id
	 */
	private Long activityId;

	/**
	 * 道路编号
	 */
	private String roadNo;

	/**
	 * 道路名称
	 */
	private String roadName;

	/**
	 * 路段编号
	 */
	private String sectionNo;

	/**
	 * 路段名称
	 */
	private String sectionName;

	/**
	 * 道路方向
	 */
	private String direction;

	/**
	 * 拥堵指数
	 */
	private String congestion;

	@JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
	private Date createOn;


	@Override
	protected Serializable pkVal() {
		return this.activityTrafficId;
	}
}
