package com.bcxin.sp.work.entity.domain.base;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 视频设备信息
 * 闪马提供
 */
@Data
@TableName("base_camera")
public class Camera extends Model<Camera> {

	private static final long serialVersionUID = 7064937058904767154L;

	@TableId(type = IdType.AUTO)
	private Long cameraId;

	/**
	 * 场馆Id
	 */
	private Long venueId;

	/**
	 * 视频设备编码	设备编号
	 */
	private String serialNumber;

	/**
	 * 设备名称	设备的详细登入名称
	 */
	private String fullName;

	/**
	 * 厂家名称
	 */
	private String factory;

	/**
	 * ip地址
	 */
	private String ipAddress;

	/**
	 * ipv6地址
	 */
	private String ipAddress6;

	/**
	 * 地球经度	作为GIS打点数据
	 */
	private String longitude;

	/**
	 * 地球维度	作为GIS打点数据
	 */
	private String latitude;

	/**
	 * 安装地点行政区域代码
	 */
	private String installAreaCode;

	/**
	 * 安装地点地址名称
	 */
	private String installAddress;

	/**
	 * 管辖单位
	 */
	private String controlOrg;


	private String controlOrgCode;

	/**
	 * 设备类型	设备类型说明
	 */
	private String deviceCameraType;

	/**
	 * 采集数据类型
	 */
	private String dataType;

	/**
	 * 监视方向
	 */
	private String monitorDirection;

	/**
	 * 监视区域说明
	 */
	private String monitorArea;

	/**
	 * 摄像机位置类型
	 */
	private String cameraPositionType;

	/**
	 * 摄像机用途
	 */
	private String cameraUse;


	/**
	 * 视频流URL	视频流地址
	 */
	private String previewUrl;

	/**
	 * 视频流URL（渲染后）	渲染后视频流地址
	 */
	private String finalPreviewUrl;

	/**
	 * 创建时间
	 */
	private Date createOn;


	@Override
	protected Serializable pkVal() {
		return this.cameraId;
	}
}
