package com.bcxin.sp.work.entity.domain.base;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import lombok.Data;

import java.io.Serializable;

/**
 * 人员
 */
@Data
@TableName("base_person")
public class Person extends Model<Person> {

	private static final long serialVersionUID = 7064937058904767154L;

	@TableId(type = IdType.INPUT)
	private Long personId;

	/**
	 * 姓名
	 */
	private String fullName;

	/**
	 * 曾用名
	 */
	private String usedName;

	/**
	 * 照片
	 */
	private String avatar;

	/**
	 * 证件类型
	 * 身份证
	 */
	private String idCardType;

	/**
	 * 证件号码
	 */
	private String idCardNo;

	/**
	 * 性别
	 */
	private String sex;

	/**
	 * 手机号
	 */
	private String mobile;

	/**
	 * 民族代码
	 */
	private String nation;

	/**
	 * 国籍代码
	 */
	private String country;
	/**
	 * 籍贯
	 */
	private String nativeAddress;

	@Override
	protected Serializable pkVal() {
		return this.personId;
	}
}
