package com.bcxin.sp.work.entity.domain.log;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import lombok.Data;

import javax.xml.bind.annotation.*;
import java.io.Serializable;

/**
 * 审计操作日志
 * 需根据系统配置是否记录
 */
@Data
@TableName("log_audit")
@XmlAccessorType(XmlAccessType.FIELD)
public class AuditLog extends Model<AuditLog> {

    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.AUTO)
    @XmlTransient
    private Long id;

    /**
     * 浙江注册码
     */
    private String Reg_ID;
    /**
     * 流水号
     */
    private String Num_ID;

    /**
     * 用户标识
     */
    private String User_ID;

    /**
     * 单位名称
     */
    private String Organization;

    private String Organization_ID;

    /**
     * 用户名
     */
    private String User_Name;

    /**
     * 终端标识
     */
    private String Terminal_ID;

    /**
     * 操作名称
     */
    private String Operate_Name;

    /**
     * 操作类型
     */
    private int Operate_Type;

    /**
     * 操作时间
     */
    private String Operate_Time;

    /**
     * 操作条件
     */
    private String Operate_Condition;

    /**
     * 操作结果
     */
    private String Operate_Result;

    /**
     * 备用字段
     */
     private String BZ1 = "1";
     private String BZ2 = "2";
     private String BZ3 = "3";
     private String BZ4 = "4";
     private String BZ5 = "5";
     private String BZ6 = "6";
     private String BZ7 = "7";
     private String BZ8 = "8";
     private String BZ9 = "9";
     private String BZ10 = "10";

   /**
     * 同步标识 1,成功，0，失败
     * @return
     */
    @XmlTransient
    private String syncStatus;

    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
