package com.bcxin.sp.work.entity.domain.log;

import com.alibaba.fastjson.annotation.JSONField;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * 差异日志
 */
@Data
@TableName("change_log")
public class ChangeLog extends Model<ChangeLog> {

	private static final long serialVersionUID = 7064937058904767154L;

	@TableId(type = IdType.AUTO)
	private Long oid;

	private Long sourceOid;

	private String activityNo;

	/**
	 * 单据id，如活动id等
	 */
	private String billId;
	/**
	 * 单据分类
	 */
	private String billCategory;

	private String keyName;

	private String text;

	/**
	 * 单据类型
	 */
	private String billType;

	/**
	 * 原始值
	 */
	private String sourceVal;

	/**
	 * 修改后值
	 */
	private String nowVal;

	/**
	 * 修改版本
	 */
	private int changeVersion;

	/**
	 * 修改日期
	 */
	private Date changeDate;

	private String isNew;

	private String flagId;

	private String source;

	/**
	 * 落地省份id
	 */
	private Long markerRegionId;

	/**
	 * 1需要推送
	 */
	private String isUpdate;



	@Override
	protected Serializable pkVal() {
		return this.oid;
	}
}
