package com.bcxin.sp.work.entity.domain.log;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * 操作日志
 */
@Data
@TableName("log_operate")
public class OperateLog extends Model<OperateLog> {

    private static final long serialVersionUID = 1L;

    @TableId(type = IdType.AUTO)
    private Long id;
    /**
     * 用户
     */
    private Long userId;
    private String userName;
    private String province;
    private String city;
    private String area;
    private String provinceName;
    private String cityName;
    private String areaName;
    /**
     * 菜单名称
     */
    private String menuName;
    /**
     * 操作类型
     */
    private String operateType;
    /**
     * 操作对象
     */
    private String operateObj;
    /**
     * 请求参数
     */
    private String params;
    /**
     * 操作结果
     */
    private int result;

    /**
     * 请求方式
     */
    private String requestMethod;

    private String requestUrl;

    /**
     * 执行开始时间
     */
    private Long startTime;
    /**
     * 结束时间
     */
    private Long endTime;
    /**
     * 耗时
     */
    private Long speedTime;
    /**
     * ip
     */
    private String ip;
    /**
     * 异常消息
     */
    private String exception;

    /**
     * 创建时间
     */
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    private Date addTime = new Date();

    @Override
    protected Serializable pkVal() {
        return this.id;
    }
}
