package com.bcxin.sp.work.entity.domain.sys;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import lombok.Data;

import java.io.Serializable;

@Data
@TableName("config_menu")
public class ConfigMenu extends Model<ConfigMenu> {

	private static final long serialVersionUID = 5141146467906163568L;

	@TableId(type = IdType.AUTO)
	private Long id;

	/**
	 * 标题
	 */
	private String title;

	/**
	 * 链接
	 */
	private String url;

	/**
	 * 角色授权允许
	 * （多个角色用逗号隔开）
	 */
	private String roleAuth;

	/**
	 * 上级菜单
	 */
	private Long parentId;

	/**
	 * 第几级菜单
	 */
	private String menuLevel;

	/**
	 * 菜单图标
	 */
	private String icon;

	/**
	 * 是否新窗口打开
	 */
	private String isNewWindow;

	/**
	 * 省级代码
	 */
	private String province;

	@Override
	protected Serializable pkVal() {
		return this.id;
	}
}
