package com.bcxin.sp.work.entity.domain.sys;

import cn.hutool.core.date.DatePattern;
import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 消息提醒
 * </p>
 *
 * @author 罗鹏
 * @date 2018/5/17
 */
@Data
@TableName("sp_message")
public class Message extends Model<Message> {

    private static final long serialVersionUID = 7064937058904767154L;

    @TableId(type = IdType.AUTO)
    private Long id;
    private Date addTime = new Date();

    private Long userId;//用户

    private String readStatus; //0代表未读，1代表已读

    private String title;

    private String content;

    private String keyword;

    private String url;

    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date readTime;

    @Override
    protected Serializable pkVal() {
        return this.id;
    }

    public String getAddTimeStr(){
        return DateUtil.format(this.addTime, DatePattern.NORM_DATETIME_MINUTE_FORMAT);
    }

}
