package com.bcxin.sp.work.entity.domain.upgrade;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.IdType;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * @author hzp
 * 系统升级内容记录表
 */
@Data
@TableName("system_upgrade")
public class SystemUpgrade extends Model<SystemUpgrade> {

    @TableId(type = IdType.AUTO)
    private Long id;

    /**
     * pss系统id
     */
    private Long pssId;

    /**
     * 系统升级标题
     */
    private String title;

    /**
     * 升级内容
     */
    private String content;

    /**
     * 升级版本
     */
    private String version;

    /**
     * 省份id
     */
    private String provinceId;

    /**
     * 市id
     */
    private String cityId;

    /**
     * 区域id
     */
    private String areaId;

    /**
     * 标识
     */
    private Integer deleteFlag;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 更新时间
     */
    private Date updateTime;

    @Override
    protected Serializable pkVal() {
        return this.id;
    }
}
