package com.bcxin.sp.work.entity.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <b> 活动对象 </b>
 * @author ZXF
 * @create 2023/11/13 0013 16:23
 * @version
 * @注意事项 </b>
 */
@Data
public class ActivityAnbaoDto implements Serializable {
    private static final long serialVersionUID = 1L;

    /**
     * 活动主键
     */
    private Long actId;

    /**
     * 活动名称
     */
    private String actName;

    /**
     * 活动编号
     */
    private String actNo;

    /**
     * 活动类型
     */
    private String actType;

    /**
     * 额定容量人数
     */
    private Long maxPersonNumber;

    /**
     * 场地面积
     */
    private String siteArea;

    /**
     * 拟发售票数
     */
    private Long soldTicketsNumber;

    /**
     * 活动开始时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    private Date beginTime;

    /**
     * 活动结束时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    private Date endTime;

    /**
     * 举办地点——活动地点的详情地址
     */
    private String holdAddr;

    /**
     * 活动内容
     */
    private String actContent;

    /**
     * 审批状态
     */
    private String approvalStatus;

    /**
     * 归档状态
     */
    private String archiveStatus;

    /**
     * 数据来源
     */
    private String dataSource;


    //以下为活动摸排和活动登记整合后新增的冗余字段
    /**
     * 是否需要安全许可--和产品确认，该字段只做标签作用
     */
    private String safeLicenseStatus;

    /**
     * 填报日期
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date actReportTime;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date createTime;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date updateTime;

    /**
     * 每日参加人数
     */
    private int dailyAttendPerson;

    /**
     * 承办单位
     */
    private String organizerUnit;

    /**
     * 承办方注册地
     */
    private String organizerRegist;

    /**
     * 填报单位
     */
    private String reportUnit;

    /**
     * 安保力量
     */
    private int securityPowerNumber;

    /**
     * 警力
     */
    private int staffNumber;

    /**
     * 保安
     */
    private int securityNumber;

    /**
     * 志愿者
     */
    private int volunteerNumber;

    /**
     * 责任单位
     */
    private String responsibleUnit;

    /**
     * 风险评估等级
     */
    private String riskLevel;

    /**
     * 现场安全检查
     */
    private String securityCheck;

    /**
     * 安保方案
     */
    private String securityProgramme;

    /**
     * 活动现场领导(职务)联系方式
     */
    private String actSiteLeaderStaffPhone;

    /**
     * 活动现场领导(职务)主键
     */
    private String actSiteLeaderStaffId;

    /**
     * 活动现场领导(职务)警号
     */
    private String actSiteLeaderStaffCode;

    /**
     * 活动现场领导(职务)名称
     */
    private String actSiteLeaderStaffName;

    /**
     * 活动现场领导(职务)所在单位
     */
    private String actSiteLeaderStationId;

    /**
     * 活动责任领导联系方式
     */
    private String actDutyLeaderStaffPhone;

    /**
     * 活动责任领导主键
     */
    private String actDutyLeaderStaffId;

    /**
     * 活动责任领导警号
     */
    private String actDutyLeaderStaffCode;

    /**
     * 活动责任领导名称
     */
    private String actDutyLeaderStaffName;

    /**
     * 活动责任领导所在单位
     */
    private String actDutyLeaderStationId;

    /**
     * 活动责任（联系）民警联系方式
     */
    private String actDutyStaffPhone;

    /**
     * 活动责任（联系）民警主键
     */
    private String actDutyStaffId;

    /**
     * 活动责任（联系）民警警号
     */
    private String actDutyStaffCode;

    /**
     * 活动责任（联系）民警名称
     */
    private String actDutyStaffName;

    /**
     * 活动责任（联系）民警所在单位
     */
    private String actDutyStationId;

    /**
     * 省份
     */
    private String province;

    /**
     * 市区
     */
    private String city;

    /**
     * 区域
     */
    private String area;

    /**
     * 许可单位
     */
    private String unit;

    /**
     * 推送数据方活动主键
     */
    private String fkId;

    /**
     * 推送数据方活动主键
     */
    private String isGov;

    /**
     * 打回理由
     */
    private String rejectContent;

    /**
     * 重新申请原因
     */
    private String reContent;
}
