package com.bcxin.sp.work.entity.dto;

/**
 * ajax返回封装类
 * @author Ethan.H
 */
public class AjaxResult {

	private String code;
	private String msg;
	private boolean successful;
	private Object obj;

	public static final String SUCCESS_MSG = "操作成功！";
	public static final String ERROR_MSG = "操作失败！";
	public static final String EMPTY = "";

	public AjaxResult(){}
	private AjaxResult(String code, String msg, boolean successful, Object obj){
		super();
		this.code = code;
		this.msg = msg;
		this.successful = successful;
		this.obj = obj;
	}

	public static AjaxResult success(String successMsg) {
		return new AjaxResult(EMPTY, successMsg, true, null);
	}

	public static AjaxResult success(String successMsg, Object obj) {
		return new AjaxResult(EMPTY, successMsg, true, obj);
	}

	public static AjaxResult fail(String errorMsg) {
		return new AjaxResult(EMPTY, errorMsg, false, null);
	}

	public static AjaxResult fail(String errorMsg, Object obj) {
		return new AjaxResult(EMPTY, errorMsg, false, obj);
	}

	public String getCode() {
		return code;
	}
	public void setCode(String code) {
		this.code = code;
	}
	public String getMsg() {
		return msg;
	}
	public void setMsg(String msg) {
		this.msg = msg;
	}
	public boolean isSuccessful() {
		return successful;
	}
	public void setSuccessful(boolean successful) {
		this.successful = successful;
	}
	public Object getObj() {
		return obj;
	}
	public void setObj(Object obj) {
		this.obj = obj;
	}
	
}
