package com.bcxin.sp.work.service.activity.approve;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.DateField;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.io.FileUtil;
import cn.hutool.core.util.StrUtil;
import com.aspose.words.Document;
import com.aspose.words.License;
import com.aspose.words.SaveFormat;
import com.bcxin.sp.work.dao.activity.approve.ApproveDetailMapper;
import com.bcxin.sp.work.dao.activity.approve.ApproveMapper;
import com.bcxin.sp.work.dao.activity.approve.ApproveRoleMapper;
import com.bcxin.sp.work.dao.activity.approve.FileNumberMapper;
import com.bcxin.sp.work.dao.activity.extend.ActivityContractorMapper;
import com.bcxin.sp.work.dao.activity.extend.ActivityDetailMapper;
import com.bcxin.sp.work.dao.activity.extend.ActivityMaterialMapper;
import com.bcxin.sp.work.dao.activity.extend.WorkflowMapper;
import com.bcxin.sp.work.dao.sys.RegionMapper;
import com.bcxin.sp.work.dao.telPhone.TelPhoneMapper;
import com.bcxin.sp.work.dao.user.UserMapper;
import com.bcxin.sp.work.entity.domain.activity.approve.Approve;
import com.bcxin.sp.work.entity.domain.activity.approve.ApproveDetail;
import com.bcxin.sp.work.entity.domain.activity.approve.ApproveRole;
import com.bcxin.sp.work.entity.domain.activity.approve.FileNumber;
import com.bcxin.sp.work.entity.domain.activity.base.Activity;
import com.bcxin.sp.work.entity.domain.activity.expand.ActivityContractor;
import com.bcxin.sp.work.entity.domain.activity.expand.ActivityDetail;
import com.bcxin.sp.work.entity.domain.activity.expand.ActivityMaterial;
import com.bcxin.sp.work.entity.domain.activity.expand.Workflow;
import com.bcxin.sp.work.entity.domain.sys.Region;
import com.bcxin.sp.work.entity.domain.user.TelPhone;
import com.bcxin.sp.work.entity.domain.user.User;
import com.bcxin.sp.work.util.Const.DictConst;
import com.bcxin.sp.work.util.Const.GlobalConst;
import com.bcxin.sp.work.util.StringUtil;
import com.bcxin.sp.work.util.sys.ConfigUtil;
import com.google.common.collect.Maps;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.ResourceUtils;

import javax.annotation.Resource;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Service
@Transactional
public class ApproveFileService {

    @Resource
    private ActivityMaterialMapper activityMaterialMapper;

    @Resource
    private UserMapper userMapper;

    @Resource
    private RegionMapper regionMapper;

    @Resource
    private WorkflowMapper workflowMapper;

    @Resource
    private ApproveRoleMapper approveRoleMapper;

    @Resource
    private ApproveDetailMapper approveDetailMapper;

    @Resource
    private ActivityContractorMapper activityContractorMapper;

    @Resource
    private ActivityDetailMapper activityDetailMapper;

    @Resource
    private TelPhoneMapper telPhoneMapper;

    @Resource
    private ApproveMapper approveMapper;

    @Resource
    private FileNumberMapper fileNumberMapper;

    /**
     * 生成受理文书
     * @return
     */
    public void generateslws(String status, Activity activity, User user) {
        FileOutputStream fileOS=null;
        try {
            File licenseFile = ResourceUtils.getFile("classpath:aspose/license.xml");
            File approvalFile = null;
            /* 受理通过 */
            if (DictConst.STATUS_SL.equals(status)) {
                approvalFile = ResourceUtils.getFile("classpath:aspose/slFile.docx");
            }
            /* 不受理 */
            else if (DictConst.STATUS_BSL.equals(status)) {
                approvalFile = ResourceUtils.getFile("classpath:aspose/bslFile.docx");
            }
            if (approvalFile == null) {
                return;
            }
            License aposeLic = new License();
            aposeLic.setLicense(FileUtil.getInputStream(licenseFile));
            BufferedInputStream word = FileUtil.getInputStream(approvalFile);
            Document docAll = new Document(word);

            String[] fieldNames = null;
            Object[] values = null;
            /* 受理通过 */
            if (DictConst.STATUS_SL.equals(status)) {

                //在文书中插入警局电话和联系人
                String policeuser = "";
                String policetel = "";

                if (user != null) {
                    String place = "";
                    if (user.getRegionLevel() == 2) {
                        place = user.getCity();
                    }
                    if (user.getRegionLevel() == 3) {
                        place = user.getArea();
                    }
                    if (StringUtil.isNotEmpty(place)) {
                        List<TelPhone> telPhone = telPhoneMapper.selectTelPhoneByLevel(user.getRegionLevel(), place);
                        if (CollectionUtil.isNotEmpty(telPhone)) {
                            policetel = telPhone.get(0).getTelPhone();
                        }
                    }
                    policeuser = user.getRealName();
                } else {
                    String place = "";
                    if (DictConst.APPROVELEVEL_CITY.equals(activity.getApproveLevel())) {
                        place = activity.getCity();
                    }
                    if (DictConst.APPROVELEVEL_AREA.equals(activity.getApproveLevel())) {
                        place = activity.getArea();
                    }
                    if (StringUtil.isNotEmpty(place)) {
                        List<TelPhone> telPhone = telPhoneMapper.selectTelPhoneByLevel(Integer.parseInt(activity.getApproveLevel()), place);
                        if (CollectionUtil.isNotEmpty(telPhone)) {
                            policetel = telPhone.get(0).getTelPhone();
                        }
                    }
                    List<Approve> approveList = approveMapper.findByActivityId(activity.getId());
                    if (CollectionUtil.isNotEmpty(approveList)) {
                        Long userId = approveList.get(0).getUserId();
                        User approveUser = userMapper.findUserById(userId);
                        policeuser = approveUser.getRealName();
                    }
                }

                fieldNames = new String[]{"police", "policealias", "year", "num"
                        , "organizer", "cyear", "cmonth", "cday", "activityname", "policeuser", "policetel",
                        "material"};
                Workflow workflow = workflowMapper.findRegionByVersion(activity.getId());
                String police = "";
                String policealias = "";

                //生成编号
                String num = numberCreate(activity, user, DictConst.FILE_NAME_SL);

                if (StrUtil.isNotEmpty(workflow.getArea())) {
                    police = workflow.getArea();
                } else if (StrUtil.isNotEmpty(workflow.getCity())){
                    police = workflow.getCity();
                    policealias = police.substring(0,1) + "公";
                } else if (StrUtil.isNotEmpty(workflow.getProvince())){
                    police = workflow.getProvince();
                }
                String material = "";
                if ("guangxi".equals(ConfigUtil.getValue("envi"))) {
                    material = GlobalConst.GUANGXI_MATERIAL;
                }
                if ("shanxi".equals(ConfigUtil.getValue("envi"))) {
                    material = GlobalConst.SHANXI_MATERIAL;
                }
                DateTime createDate = new DateTime(activity.getAddTime());
                values = new Object[]{ police, policealias, DateUtil.thisYear()
                        , num
                        ,activity.getSponsor()
                        ,createDate.getField(DateField.YEAR)
                        ,createDate.getField(DateField.MONTH)+1
                        ,createDate.getField(DateField.DAY_OF_MONTH)
                        ,activity.getFullName()
                        , policeuser
                        , policetel
                        ,material};
            }
            /* 不受理 */
            else if (DictConst.STATUS_BSL.equals(status)) {
                fieldNames = new String[]{"police", "policealias", "year", "num"
                        ,"organizer", "activityname","rejectreason","area"};

                Workflow workflow = workflowMapper.findRegionByVersion(activity.getId());
                String region = StrUtil.isEmpty(workflow.getArea())?workflow.getCity():workflow.getArea() ;
                String police = "";
                String policealias = "";

                //生成编号
                String num = numberCreate(activity, user, DictConst.FILE_NAME_BYSL);

                if (StrUtil.isNotEmpty(workflow.getArea())) {
                    police = workflow.getArea();
                } else if (StrUtil.isNotEmpty(workflow.getCity())){
                    police = workflow.getCity();
                    policealias = police.substring(0,1) + "公";
                } else if (StrUtil.isNotEmpty(workflow.getProvince())){
                    police = workflow.getProvince();
                }
                values = new Object[]{ police, policealias, DateUtil.thisYear()
                        , num
                        ,activity.getSponsor(),activity.getFullName()
                        ,activity.getRejectContent()
                        ,region};
            }
            docAll.getMailMerge().execute(fieldNames, values);

            String fileName = System.currentTimeMillis() + ".docx";
            String dir = ConfigUtil.getValue("stuff-path") + DateUtil.today();
            FileUtil.mkdir(dir);
            //输出路径
            File file = new File(dir + File.separator + fileName);
            fileOS = new FileOutputStream(file);
            docAll.save(fileOS, SaveFormat.DOC);

            String fileUrl = GlobalConst.PACK_DOWNLOAD + file.getPath();

            ActivityMaterial material = activityMaterialMapper.findByActivityId(activity.getId());
            material.setSlws(fileUrl);
            activityMaterialMapper.updateById(material);
        } catch (Exception e) {
            e.printStackTrace();
        }finally {
            try {
                if(fileOS!=null) {
                    fileOS.close();
                }
            }catch (Exception e){
                e.printStackTrace();
            }
        }
    }

    /**
     * 生成编号
     *
     * @param activity
     * @param user
     * @param fileName
     * @return
     */
    private String numberCreate(Activity activity, User user, String fileName) {

        if (activity != null) {

            FileNumber newFileNumber = new FileNumber();
            newFileNumber.setAddTime(new Date());
            newFileNumber.setActivityId(activity.getId());
            newFileNumber.setProvince(activity.getProvince());
            newFileNumber.setUserId(user.getId());
            newFileNumber.setFileName(activity.getFullName() + "-" + fileName);

            // 市级审批
            if("2".equals(activity.getApproveLevel())){
                newFileNumber.setCity(activity.getCity());
            }
            // 区级审批
            else if("3".equals(activity.getApproveLevel())){
                newFileNumber.setCity(activity.getCity());
                newFileNumber.setArea(activity.getArea());
            }

            //审批等级只有2或者3
            if ("2".equals(activity.getApproveLevel()) || "3".equals(activity.getApproveLevel())) {

                String city=activity.getCity();
                String area=activity.getArea();
                String approvalLevel=activity.getApproveLevel()+"";
//                List<FileNumber> fileNumberList = fileNumberMapper.selectFileNumber(activity.getCity(), activity.getArea(), activity.getApproveLevel());
                // 市走市，区走区
                List<FileNumber> fileNumberList = fileNumberMapper.selectFileNumber(city, area, approvalLevel);
                String num = "001";
                int sort = 1;
                if (fileNumberList != null && fileNumberList.size() > 0) {
                    FileNumber fileNumber = fileNumberList.get(0);
                    if (fileNumber != null) {
                        sort = fileNumber.getSort();
                        sort = sort + 1;
                        if (sort < 10) {
                            num = "00" + sort;
                        } else if (sort >= 10 && sort < 100) {
                            num = "0" + sort;
                        } else if (sort >= 100) {
                            num = sort + "";
                        }
                    }

                }
                newFileNumber.setSort(sort);
                newFileNumber.setFileNumber(num);
                fileNumberMapper.insert(newFileNumber);
                return num;
            }
        }
        return "";
    }

    /**
     * 生成许可决定书
     * @return
     */
    public void generatexkjds(String status,Activity activity) {
        FileOutputStream fileOS=null;
        try {
            File licenseFile = ResourceUtils.getFile("classpath:aspose/license.xml");
            File approvalFile = null;
            /* 审批通过 */
            if (DictConst.STATUS_YES.equals(status)) {
                approvalFile = ResourceUtils.getFile("classpath:aspose/approvalFile.docx");
            }
            /* 审批不通过 */
            else if (DictConst.STATUS_NO.equals(status)) {
                approvalFile = ResourceUtils.getFile("classpath:aspose/noApprovalFile.docx");
            }
            if (approvalFile == null) {
                return;
            }
            License aposeLic = new License();
            aposeLic.setLicense(FileUtil.getInputStream(licenseFile));
            BufferedInputStream word = FileUtil.getInputStream(approvalFile);
            Document docAll = new Document(word);

            String[] fieldNames = null;
            Object[] values = null;
            /* 审批通过 */
            if (DictConst.STATUS_YES.equals(status)) {
                fieldNames = new String[]{"police","policealias","year","num"
                        ,"organizer","cyear","cmonth","cday","activity",
                        "syear", "smonth", "sday","shour","smin"
                        ,"eyear", "emonth", "eday","ehour", "emin","address"};

                List<Approve> approveList = approveMapper.findRecordByActivityId(activity.getId());
                Approve approve = approveList.get(0);
                User user = userMapper.findUserById(approve.getUserId());
                String police = "";
                String policealias = "";
                String num =numberCreate(activity,user,DictConst.FILE_NAME_XK);

                if (StrUtil.isNotEmpty(user.getAreaname())) {
                    police = user.getAreaname();
                } else if (StrUtil.isNotEmpty(user.getCityname())){
                    police = user.getCityname();
                    policealias = police.substring(0,1) + "公";
                } else if (StrUtil.isNotEmpty(user.getProvincename())){
                    police = user.getProvincename();
                }
                DateTime createDate = new DateTime(activity.getAddTime());
                DateTime startDate = new DateTime(activity.getStartDate());
                DateTime endDate = new DateTime(activity.getEndDate());
                values = new Object[]{ police, policealias, DateUtil.thisYear()
                        ,num
                        ,activity.getSponsor()
                        ,createDate.getField(DateField.YEAR)
                        ,createDate.getField(DateField.MONTH)+1
                        ,createDate.getField(DateField.DAY_OF_MONTH)
                        ,activity.getFullName()
                        ,startDate.getField(DateField.YEAR)
                        ,startDate.getField(DateField.MONTH)+1
                        ,startDate.getField(DateField.DAY_OF_MONTH)
                        ,startDate.isAM()?startDate.getField(DateField.HOUR): startDate.getField(DateField.HOUR)+12
                        ,startDate.getField(DateField.MINUTE)
                        ,endDate.getField(DateField.YEAR)
                        ,endDate.getField(DateField.MONTH)+1
                        ,endDate.getField(DateField.DAY_OF_MONTH)
                        ,endDate.isAM()?endDate.getField(DateField.HOUR): endDate.getField(DateField.HOUR)+12
                        ,endDate.getField(DateField.MINUTE)
                        ,activity.getAddress()};
            }
            /* 审批不通过 */
            else if (DictConst.STATUS_NO.equals(status)) {
                fieldNames = new String[]{"police","policealias","year","num"
                        ,"organizer", "syear", "smonth", "sday","shour","smin"
                        ,"eyear", "emonth", "eday","ehour", "emin"
                        ,"address", "activity","rejectreason","area"};

                List<Approve> approveList = approveMapper.findRecordByActivityId(activity.getId());
                Approve approve = approveList.get(0);
                User user = userMapper.findUserById(approve.getUserId());
                Long userAreaId = Long.parseLong(StrUtil.isEmpty(user.getArea())?user.getCity():user.getArea());
                Region region = regionMapper.selectById(userAreaId);
                String police = "";
                String policealias = "";
                //生成编号
                String num =numberCreate(activity,user,DictConst.FILE_NAME_BYXK);

                if (StrUtil.isNotEmpty(user.getAreaname())) {
                    police = user.getAreaname();
                } else if (StrUtil.isNotEmpty(user.getCityname())){
                    police = user.getCityname();
                    policealias = police.substring(0,1) + "公";
                } else if (StrUtil.isNotEmpty(user.getProvincename())){
                    police = user.getProvincename();
                }
                DateTime startDate = new DateTime(activity.getStartDate());
                DateTime endDate = new DateTime(activity.getEndDate());

                values = new Object[]{ police, policealias, DateUtil.thisYear()
                        ,num
                        ,activity.getSponsor()
                        ,startDate.getField(DateField.YEAR)
                        ,startDate.getField(DateField.MONTH)+1
                        ,startDate.getField(DateField.DAY_OF_MONTH)
                        ,startDate.isAM()?endDate.getField(DateField.HOUR): endDate.getField(DateField.HOUR)+12
                        ,startDate.getField(DateField.MINUTE)
                        ,endDate.getField(DateField.YEAR)
                        ,endDate.getField(DateField.MONTH)+1
                        ,endDate.getField(DateField.DAY_OF_MONTH)
                        ,endDate.isAM()?endDate.getField(DateField.HOUR): endDate.getField(DateField.HOUR)+12
                        ,endDate.getField(DateField.MINUTE)
                        ,activity.getAddress()
                        ,activity.getFullName()
                        ,activity.getRejectContent()
                        ,region.getFullName()};
            }
            docAll.getMailMerge().execute(fieldNames, values);

            String fileName = System.currentTimeMillis() + ".docx";
            String dir = ConfigUtil.getValue("stuff-path") + DateUtil.today();
            FileUtil.mkdir(dir);
            File file = new File(dir + File.separator + fileName); //输出路径
            fileOS = new FileOutputStream(file);
            docAll.save(fileOS, SaveFormat.DOC);

            String fileUrl = GlobalConst.PACK_DOWNLOAD + file.getPath();

            ActivityMaterial material = activityMaterialMapper.findByActivityId(activity.getId());
            material.setXkjds(fileUrl);
            activityMaterialMapper.updateById(material);
        } catch (Exception e) {
            e.printStackTrace();
        }finally {
            try{
                if(fileOS!=null){
                    fileOS.close();
                }
            }catch (Exception e){
                e.printStackTrace();
            }
        }
    }


    /**
     * 生成安全许可审批表
     * @return
     */
    public void generateaqxkspb(Activity activity) {
        FileOutputStream fileOS=null;
        try {
            File licenseFile = ResourceUtils.getFile("classpath:aspose/license.xml");
            File approvalFile = null;
            //区分 温州市 跟其它地区 使用的模板
            if(StringUtil.isNotEmpty(activity.getCity())&&"330300".equals(activity.getCity())){
                approvalFile = ResourceUtils.getFile("classpath:aspose/aqxkspb_wz.docx");
            }else{
                approvalFile = ResourceUtils.getFile("classpath:aspose/aqxkspb.docx");
            }
            License aposeLic = new License();
            aposeLic.setLicense(FileUtil.getInputStream(licenseFile));
            BufferedInputStream word = FileUtil.getInputStream(approvalFile);
            Document docAll = new Document(word);

            String[] fieldNames = null;
            Object[] values = null;
                fieldNames = new String[]{"areaname","activityName","sponsor","nowDate"
                        ,"number","content","securityCompany","securityNum","venueNum",
                        "contractor","approvalInfo"};
            Workflow workflow = workflowMapper.findRegionByVersion(activity.getId());
            String areaname = "";
            if (StrUtil.isNotEmpty(workflow.getCity())){
                areaname = workflow.getCity();
            } else if (StrUtil.isNotEmpty(workflow.getProvince())){
                areaname = workflow.getProvince();
            }
            ActivityDetail activityDetail = activityDetailMapper.findByActivityId(activity.getId());
            String content="";
            String securityCompany="";
            String securityNum="";
            String venueNum="";

            if (activityDetail != null) {
                content = activityDetail.getHdnr();
                securityCompany = activityDetail.getBags();
                securityNum = activityDetail.getBaryzs();
                venueNum = activityDetail.getCdrl();
            }

            String contact = "";
            //区分 温州市 跟其它地区 使用的模板个别参数的取值
            if(StringUtil.isNotEmpty(activity.getCity())&&"330300".equals(activity.getCity())){
                //经办人
                contact = approveMapper.findOneApprovePoliceName(activity.getId());
            }else{
                //承办人
                ActivityContractor activityContractor = activityContractorMapper.selectContactByActivityId(activity.getId());
                if(activityContractor != null){
                    contact = activityContractor.getContact();
                }
            }
            StringBuffer approvalInfo = new StringBuffer();
            List<Approve> approves = approveMapper.findByActivityOrderBySeq(activity.getId());
            Map<String,Approve> approveMap = Maps.newHashMap();
            if (CollectionUtil.isNotEmpty(approves) ) {
                for (Approve approve : approves) {
                    User approveUser = userMapper.findUserById(approve.getUserId());
                    approveMap.put(approveUser.getWorkRole(),approve);
                }
            }

            /* 如果审批流程没有结束，需要把之后流程的审批级别都展示出来 */
            List<Workflow> workflows = workflowMapper.findByVersion(activity.getWorkflowVersion());
            for (Workflow flow:workflows) {
                String role = flow.getRole();
                Approve approve = approveMap.get(role);
                ApproveRole approveRole = approveRoleMapper.findById(Long.parseLong(role));

                String action = "";
                if (flow.getSeq() == 1) {
                    action = "意见：";
                } else {
                    action = "批示：";
                }

                /* 未审批*/
                if (approve == null) {
                    approvalInfo.append(approveRole.getFullName() + action + (char) 11 + (char) 11);
                }
                /* 已经审批 */
                else {
                    approvalInfo.append(approveRole.getFullName() + action);
                    if (DictConst.STATUS_YES.equals(approve.getApprove())) {
                        approvalInfo.append("许可。" + (char) 11);
                    } else if (DictConst.STATUS_NO.equals(approve.getApprove())) {
                        approvalInfo.append("不许可。" + (char) 11);
                        approvalInfo.append("不许可意见："+activity.getRejectContent() + (char) 11);
                    } else if (DictConst.STATUS_REJECT.equals(approve.getApprove())) {
                        approvalInfo.append("打回。" + (char) 11);
                        approvalInfo.append("打回意见：" + activity.getRejectContent() + (char) 11);
                    }

                    List<ApproveDetail> details = approveDetailMapper.findByApproveId(approve.getId());
                    if (CollectionUtil.isNotEmpty(details)) {
                        approvalInfo.append("检查情况：");
                    }
                    details.forEach(detail -> {
                        if (StringUtil.isNotEmpty(detail.getSituation())) {
                            approvalInfo.append(detail.getSituation() + (char) 11 + (char) 11);
                        }
                    });
                }
            }

            values = new Object[]{ areaname,
                activity.getFullName(),
                activity.getSponsor(),
                DateUtil.format(new Date(),"yyyy年MM月dd日"),
                activity.getNumber(),
                content,
                securityCompany,
                securityNum,
                venueNum,
                contact,
                approvalInfo.toString()
            };
            docAll.getMailMerge().execute(fieldNames, values);

            String fileName = System.currentTimeMillis() + ".docx";
            String dir = ConfigUtil.getValue("stuff-path") + DateUtil.today();
            FileUtil.mkdir(dir);
            File file = new File(dir + File.separator + fileName); //输出路径
            fileOS = new FileOutputStream(file);
            docAll.save(fileOS, SaveFormat.DOC);

            String fileUrl = GlobalConst.PACK_DOWNLOAD + file.getPath();

            ActivityMaterial activityMaterial = activityMaterialMapper.findByActivityId(activity.getId());
            activityMaterial.setAqxkspb(fileUrl);
            activityMaterialMapper.updateById(activityMaterial);
        } catch (Exception e) {
            e.printStackTrace();
        }finally {
            try{
                if(fileOS!=null){
                    fileOS.close();
                }
            }catch (Exception e){
                e.printStackTrace();
            }
        }
    }

}
