package com.bcxin.sp.work.service.activity.plan;

import com.bcxin.sp.work.dao.activity.plan.ActivityPlanMapper;
import com.bcxin.sp.work.entity.PageResult;
import com.bcxin.sp.work.entity.domain.activity.plan.ActivityPlan;
import com.bcxin.sp.work.entity.dto.SearchDto;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;

@Service
@Transactional
public class ActivityPlanService {

    @Resource
    private ActivityPlanMapper activityPlanMapper;

    public ActivityPlan save(ActivityPlan plan) {
        activityPlanMapper.insert(plan);
        return plan;
    }

    public ActivityPlan findById(long id) {
        return activityPlanMapper.selectById(id);
    }

    public PageResult findPlanListData(SearchDto<ActivityPlan> dto) throws Exception {
        List<ActivityPlan> list = activityPlanMapper.findPlanListData(dto);
        Long total = activityPlanMapper.findPlanListDataCnt(dto);
        return new PageResult(list, total);
    }

    public ActivityPlan createOrUpdate(ActivityPlan plan) {
        if (plan.getActivityPlanId() != null) {
            plan.setUpdateTime(new Date());
            activityPlanMapper.updateById(plan);
        } else {
            plan.setAddTime(new Date());
            activityPlanMapper.insert(plan);
        }
        return plan;
    }

    public void delete(long id) {
        activityPlanMapper.deleteById(id);
    }

}
