package com.bcxin.sp.work.service.activity.security;

import cn.hutool.core.date.DateUtil;
import com.bcxin.sp.work.dao.activity.security.SecurityTaskMapper;
import com.bcxin.sp.work.entity.PageResult;
import com.bcxin.sp.work.entity.dto.SearchDto;
import com.bcxin.sp.work.entity.dto.SecurityTaskDTO;
import com.bcxin.sp.work.entity.dto.SecurityTaskPersonDTO;
import com.bcxin.sp.work.entity.dto.SecurityTaskPersonTrackDTO;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Service
@Transactional
public class SecurityTaskService {

    @Resource
    private SecurityTaskMapper securityTaskMapper;

    /**
     * <b> 根据活动查询安保任务 </b>
     *
     * @author ZXF
     * @create 2020/02/28 0028 15:03
     * @version
     * @注意事项 </b>
     */
    public List<Map> findSecurityTaskListByActivityId(long activityId) {
        return securityTaskMapper.findSecurityTaskListByActivityId(activityId);
    }

    public PageResult findAbrwListData(SearchDto<SecurityTaskDTO> dto) throws Exception {
        List<SecurityTaskDTO> list = securityTaskMapper.findAbrwListData(dto);
        Long total = securityTaskMapper.findAbrwListDataCnt(dto);
        return new PageResult(list, total);
    }

    public PageResult findLxgjListData(SearchDto<SecurityTaskPersonTrackDTO> dto) throws Exception {
        List<SecurityTaskPersonTrackDTO> list = securityTaskMapper.findLxgjListData(dto);
        Long total = securityTaskMapper.findLxgjListDataCnt(dto);
        return new PageResult(list, total);
    }

    public Map getAbrwListData(Long taskId) throws Exception {
        return securityTaskMapper.getAbrwListData(taskId);
    }

    public PageResult findRwbaryListData(SearchDto<SecurityTaskPersonDTO> dto) throws Exception {
        List<SecurityTaskPersonDTO> list = securityTaskMapper.findRwbaryListData(dto);
        list.stream().filter(s -> {
                    s.setAge(DateUtil.ageOfNow(s.getBirthday()));
                    return true;
                }
        ).collect(Collectors.toList());
        Long total = securityTaskMapper.findRwbaryListDataCnt(dto);
        return new PageResult(list, total);
    }

}
