package com.bcxin.sp.work.service.activity.survey;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.baomidou.mybatisplus.plugins.Page;
import com.bcxin.sp.work.dao.activity.survey.SurveyDetailMapper;
import com.bcxin.sp.work.dao.activity.survey.SurveyMapper;
import com.bcxin.sp.work.entity.PageResult;
import com.bcxin.sp.work.entity.domain.activity.survey.Survey;
import com.bcxin.sp.work.entity.domain.activity.survey.SurveyDetail;
import com.bcxin.sp.work.entity.dto.ActivitySurveyDTO;
import com.bcxin.sp.work.entity.dto.accident.ActivitySurveySearchDTO;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;

@Service
@Transactional
public class SurveyService {

	@Resource
	private SurveyMapper surveyDao;
	
	@Resource
	private SurveyDetailMapper surveyInfoDao;



	public Survey save(Survey survey) {
		surveyDao.insert(survey);
		return survey;
	}

	public void update(Survey survey) {
		surveyDao.updateById(survey);
	}

	public void save(SurveyDetail surveyDetail) {
		surveyInfoDao.insert(surveyDetail);
	}

	public void update(SurveyDetail surveyDetail) {
		surveyInfoDao.updateById(surveyDetail);
	}

	public List<Survey> findAll() {
		return surveyDao.selectList(new EntityWrapper<Survey>());
	}

	public List<Survey> findByActivity(Long activityId) {
		return surveyDao.findByActivityId(activityId);
	}

	public List<Survey> findRepair() {
		return surveyDao.findRepair();
	}

	public Survey findByStep(String activityNo,String address,String step) {
		return surveyDao.findByStep(activityNo, address,step);
	}

	public List<SurveyDetail> findBySurveyId(Survey survey) {
		return surveyInfoDao.findBySurveyId(survey.getId());
	}

	public void deleteInfo(Survey survey){
		surveyInfoDao.delete(new EntityWrapper<SurveyDetail>().eq("surveyId",survey.getId()));
	}

	/**
	 * 列表
	 * @param searchDTO
	 * @return
	 */
	public PageResult findActivitySurveyList(ActivitySurveySearchDTO searchDTO) {
//        PageHelper.startPage(1, 10);
		Page<ActivitySurveyDTO> page = new Page<>(searchDTO.getIDisplayStart()/searchDTO.getIDisplayLength()+1, searchDTO.getIDisplayLength());
		List<ActivitySurveyDTO> list = surveyDao.findAllByUpdateTime(page, searchDTO);
		return new PageResult(list, (long) page.getTotal());
	}

	/**
	 * 详情
	 * @param id
	 * @return
	 */
	public ActivitySurveyDTO findActivitySurveyDetail(Long id) {
		return surveyDao.selectByPrimaryKey(id);
	}
}
