package com.bcxin.sp.work.service.sys;

import cn.hutool.core.collection.CollectionUtil;
import com.bcxin.sp.work.dao.sys.CSMsgTemplateMapper;
import com.bcxin.sp.work.entity.domain.activity.base.Activity;
import com.bcxin.sp.work.entity.domain.sys.CSMsgTemplate;
import com.bcxin.sp.work.entity.domain.user.User;
import com.bcxin.sp.work.util.Const.DictConst;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional
public class CSMsgTemplateService {

    @Autowired
    private CSMsgTemplateMapper PrimaryNoticeDao;

    public CSMsgTemplate findById(long id) {
        return PrimaryNoticeDao.selectById(id);
    }

    public CSMsgTemplate save(CSMsgTemplate CSMsgTemplate, User user) {
        CSMsgTemplate.setProvince(user.getProvince());
        CSMsgTemplate.setCity(user.getCity());
        CSMsgTemplate.setArea(user.getArea());
        CSMsgTemplate.setActive(DictConst.Y);
        PrimaryNoticeDao.insert(CSMsgTemplate);
        return CSMsgTemplate;
    }


    public CSMsgTemplate findPrimaryNoticeByArea(User user) {
        List<CSMsgTemplate> list = PrimaryNoticeDao.findPrimaryNoticeByArea(user.getProvince(),user.getCity(),user.getArea());
        if (CollectionUtil.isEmpty(list)) {
            return null;
        }
        return list.get(0);
    }

    public CSMsgTemplate findPrimaryNoticeByArea(Activity activity) {
        List<CSMsgTemplate> list = PrimaryNoticeDao.findPrimaryNoticeByArea(activity.getProvince(),activity.getCity(),activity.getArea());
        if (CollectionUtil.isEmpty(list)) {
            return null;
        }
        return list.get(0);
    }


    public CSMsgTemplate findPrimaryNoticeByArea(String province, String city, String area) {
        List<CSMsgTemplate> list = PrimaryNoticeDao.findPrimaryNoticeByArea(province,city,area);
        if (CollectionUtil.isEmpty(list)) {
            return null;
        }
        return list.get(0);
    }


    public void update(CSMsgTemplate CSMsgTemplate) {
        PrimaryNoticeDao.updateById(CSMsgTemplate);
    }


}
