package com.bcxin.sp.work.service.sys;

import cn.hutool.core.collection.CollUtil;
import com.bcxin.sp.work.entity.domain.sys.ConfigMenu;
import com.bcxin.sp.work.entity.domain.user.User;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;

@Service
@Transactional
public class ConfigMenuService {

    @Resource
    private com.bcxin.sp.work.dao.sys.ConfigMenuMapper configMenuMapper;


    public List<ConfigMenu> selectByRole(String role, String province) {
        return configMenuMapper.selectByRole(role,province);
    }

    public List<ConfigMenu> getUserMenu(User user) {
        List<ConfigMenu> list = configMenuMapper.selectByUserId(user.getId(),user.getProvince());
        if (CollUtil.isEmpty(list)) {
            list = selectByRole(user.getRole(),user.getProvince());
        }
        return list;
    }

}
