package com.bcxin.sp.work.service.sys;

import com.bcxin.sp.work.dao.sys.MessageMapper;
import com.bcxin.sp.work.entity.domain.sys.Message;
import com.bcxin.sp.work.entity.domain.user.User;
import com.bcxin.sp.work.entity.dto.SearchDto;
import com.bcxin.sp.work.util.Const.DictConst;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;

@Service
@Transactional
public class MessageService {

    @Resource
    private MessageMapper messageMapper;

    public void instance(Long id,String title,String content){
        Message message = new Message();
        message.setReadStatus(DictConst.N);
        message.setAddTime(new Date());
        message.setContent(content);
        message.setTitle(title);
        message.setUserId(id);
        messageMapper.insert(message);
    }

    public void instance(Long id,String title,String content,String keyword,String url){
        Message message = new Message();
        message.setReadStatus(DictConst.N);
        message.setAddTime(new Date());
        message.setContent(content);
        message.setTitle(title);
        message.setUserId(id);
        message.setKeyword(keyword);
        message.setUrl(url);
        messageMapper.insert(message);
    }

    public void read(String messageId) {
        Message message = messageMapper.selectById(Long.parseLong(messageId));
        message.setReadStatus(DictConst.Y);
        messageMapper.updateById(message);
    }

    public List<Message> findMessageByUser(SearchDto<Message> dto,User user) {
        return messageMapper.findMessageByUser(user.getId(),dto.getIDisplayStart(),dto.getIDisplayLength());
    }

    public Long findCountOfMessage(User user) {
        return messageMapper.findCountOfMessage(user.getId());
    }

    public List<Message> searchMessage(SearchDto<Message> dto) {
        return messageMapper.searchMessage(dto);
    }
    public Long searchCountOfMessage(SearchDto<Message> dto) {
        return messageMapper.searchCountOfMessage(dto);
    }

}
