/**
 * date: 2020-04-26 17:58
 * copyright(c) 2015-2020 百川信
 */
package com.bcxin.sp.work.service.third.activityIsr;

import com.baomidou.mybatisplus.plugins.Page;
import com.bcxin.sp.work.dao.activity.isr.ActivityIsrMapper;
import com.bcxin.sp.work.entity.PageResult;
import com.bcxin.sp.work.entity.domain.activity.isr.ActivityIsr;
import com.bcxin.sp.work.entity.dto.accident.ActivityIsrSearchDTO;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author: wangjianjun
 * @description:
 * @data: 2020-04-26 17:58
 **/
@Service
public class ActivityIsrService {

    @Resource
    private ActivityIsrMapper activityIsrMapper;

    /**
     * 列表
     * @param searchDTO
     * @return
     */
    public PageResult findActivityIsrList(ActivityIsrSearchDTO searchDTO) {
//        PageHelper.startPage(1, 10);
        Page<ActivityIsr> page = new Page<>(searchDTO.getIDisplayStart()/searchDTO.getIDisplayLength()+1, searchDTO.getIDisplayLength());
        List<ActivityIsr> list = activityIsrMapper.selectAllByIsrTypeAndIsrDate(page, searchDTO);
        return new PageResult(list, (long) page.getTotal());
    }

    /**
     * 详情
     * @param id
     * @return
     */
    public ActivityIsr findActivityIsrDetail(Long id) {
        return activityIsrMapper.selectByPrimaryKey(id);
    }
}