/**
 * date: 2020-04-26 17:58
 * copyright(c) 2015-2020 百川信
 */
package com.bcxin.sp.work.service.third.activityIsr;

import com.baomidou.mybatisplus.plugins.Page;
import com.bcxin.sp.work.dao.activity.isr.ActivityPoliceIsrMapper;
import com.bcxin.sp.work.entity.PageResult;
import com.bcxin.sp.work.entity.domain.activity.isr.ActivityPoliceIsr;
import com.bcxin.sp.work.entity.dto.accident.ActivityPoliceIsrrSearchDTO;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author: wangjianjun
 * @description:
 * @data: 2020-04-26 17:58
 **/
@Service
public class ActivityPoliceIsrService {

    @Resource
    private ActivityPoliceIsrMapper policeAccidentMapper;

    /**
     * 警情数据-列表
     * @param searchDTO
     * @return
     */
    public PageResult findPoliceIsrList(ActivityPoliceIsrrSearchDTO searchDTO) {
//        PageHelper.startPage(1, 10);
        Page<ActivityPoliceIsr> page = new Page<ActivityPoliceIsr>((int) searchDTO.getIDisplayStart()/(int) searchDTO.getIDisplayLength()+1, (int) searchDTO.getIDisplayLength());
        List<ActivityPoliceIsr> list = policeAccidentMapper.findAllByAccidentNameOrAccidentPlaceName(page, searchDTO);
        return new PageResult(list, (long) page.getTotal());
    }

    /**
     * 警情数据-详情
     * @param id
     * @return
     */
    public ActivityPoliceIsr findPoliceIsr(Long id) {
        return policeAccidentMapper.selectByPrimaryKey(id);
    }
}