package com.bcxin.sp.work.service.third.bim;

import com.baomidou.mybatisplus.plugins.Page;
import com.bcxin.sp.work.dao.third.bim.DrawingMapper;
import com.bcxin.sp.work.dao.third.bim.VenueDrawingMapper;
import com.bcxin.sp.work.entity.PageResult;
import com.bcxin.sp.work.entity.domain.third.bim.Drawing;
import com.bcxin.sp.work.entity.domain.third.bim.VenueDrawing;
import com.bcxin.sp.work.entity.dto.accident.ActivityIsrSearchDTO;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;

/**
 * @Classname DrawingService
 * @Description TODO
 * @Date 2020/5/28 15:56
 * @Created by TomHanks
 */
@Service
public class DrawingService {

    @Resource
    private DrawingMapper drawingMapper;

    @Resource
    private VenueDrawingMapper venueDrawingMapper;


    public int deleteByPrimaryKey(Long id) {
        return drawingMapper.deleteByPrimaryKey(id);
    }

    @Transactional(rollbackFor = Exception.class)
    public int insert(Drawing record) {
        drawingMapper.insert(record);
        VenueDrawing venueDrawing = new VenueDrawing();
        venueDrawing.setDrawingId(record.getId());
        venueDrawing.setVenueId(Long.valueOf(record.getFullName()));
        venueDrawingMapper.insert(venueDrawing);
        return 1;
    }


    public int insertSelective(Drawing record) {
        return drawingMapper.insertSelective(record);
    }


    public Drawing selectByPrimaryKey(Long id) {
        return drawingMapper.selectByPrimaryKey(id);
    }


    public int updateByPrimaryKeySelective(Drawing record) {
        return drawingMapper.updateByPrimaryKeySelective(record);
    }


    public int updateByPrimaryKey(Drawing record) {
        return drawingMapper.updateByPrimaryKey(record);
    }



    public PageResult findAll(ActivityIsrSearchDTO searchDTO) {
        Page<Drawing> page = new Page<>(searchDTO.getIDisplayStart()/searchDTO.getIDisplayLength()+1, searchDTO.getIDisplayLength());
        List<Drawing> list = drawingMapper.findAll(page);
        return new PageResult(list, (long) page.getTotal());
//        return drawingMapper.findAll(Page );
    }
}
