package com.bcxin.sp.work.service.third.nxzw;

import cn.hutool.core.util.IdUtil;
import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSONObject;
import com.bcxin.sp.work.dao.activity.approve.ApproveHistoryMapper;
import com.bcxin.sp.work.dao.activity.base.ActivityMapper;
import com.bcxin.sp.work.dao.activity.extend.ActivityContractorMapper;
import com.bcxin.sp.work.dao.activity.extend.ActivityMaterialMapper;
import com.bcxin.sp.work.entity.domain.activity.approve.ApproveHistory;
import com.bcxin.sp.work.entity.domain.activity.base.Activity;
import com.bcxin.sp.work.entity.domain.activity.expand.ActivityContractor;
import com.bcxin.sp.work.entity.domain.activity.expand.ActivityMaterial;
import com.bcxin.sp.work.service.third.nxzw.enums.Area;
import com.bcxin.sp.work.util.BcxinDateUtil;
import com.bcxin.sp.work.util.Const.DictConst;
import com.bcxin.sp.work.util.DateUtils;
import com.bcxin.sp.work.util.nx.SMEncryptUtil;
import com.bcxin.sp.work.util.sys.ConfigUtil;
import com.bcxin.sp.work.util.sys.DateUtil;
import com.google.common.collect.Lists;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * <b> 办件推送接口 </b>
 * @author ZXF
 * @create 2022/11/15 0015 10:53
 * @version
 * @注意事项 </b>
 */
@Service
@Slf4j
public class NxSJGJService {

//    private static String NX_CLIENTID="SJHJ_BAJG";
//    private static String NX_SECRETID="SJHJBAJG";
//    private static String NX_QUERY_URL="http://10.196.47.242:9012/docking/tsk-apply/";

    @Resource
    private ActivityMapper activityMapper;

    @Resource
    private ApproveHistoryMapper approveHistoryMapper;

    @Autowired
    private ActivityContractorMapper activityContractorMapper;

    @Resource
    private ActivityMaterialMapper activityMaterialMapper;

    /**
     * 收件
     */
    public boolean receive1(Long activityId) {
        Activity activity = activityMapper.findFullById(activityId);
        String cdBatch = IdUtil.simpleUUID();
        String timestamp = System.currentTimeMillis()+"";
        String sign = SMEncryptUtil.sm3Encrypt(ConfigUtil.getValue("NX_CLIENTID") + "|" + ConfigUtil.getValue("NX_SECRETID") + "|"+ timestamp);
        UpProBody body = new UpProBody(ConfigUtil.getValue("NX_CLIENTID"),timestamp,sign,String.valueOf(activityId));
        body.setUpProAccept(setUpProAccept(activity,cdBatch));
        body.setUpProResult(setUpProResult(activity,cdBatch));
        body.setUpProMaterial(setUpProMaterialList(activity));
        body.setUpProProcess(setUpProProcessList(activity));
        body.setUpProSpecialProcedure(setUpProSpecialProcedureList(activity,cdBatch));

        String token = getToken();
        if(StringUtils.isEmpty(token)){
            return false;
        }
        System.out.println("Token:"+token);
        String resbody = JSONObject.toJSONString(body);
        System.out.println("请求报文1:"+resbody);
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("resbody",SMEncryptUtil.sm4Encrypt(resbody));
//        System.out.println("请求报文2:"+jsonObject.toJSONString());
        // token鉴权
        String ret = HttpRequest.post(ConfigUtil.getValue("NX_QUERY_URL")+"collection")
                .header("Authorization", token)
//                .body(resbody)
                .body(jsonObject.toJSONString())
                .execute().body();
        System.out.println("返回报文:"+ret);
        if(StringUtils.isNotEmpty(ret)){
            ResultNX result = JSONObject.parseObject(ret,ResultNX.class);
            if(result.getCode()==200){
                return true;
            }
        }
        return false;
    }

    private UpProAccept setUpProAccept(Activity activity,String cdBatch){
        UpProAccept upProAccept = new UpProAccept();
        upProAccept.setAcceptDate("2022-09-22 18:11:43");
        upProAccept.setAcceptDocNo("");
        upProAccept.setAddress(activity.getAddress());
        upProAccept.setApplyDate("2022-09-22 18:11:43");
        upProAccept.setApplyType("1");
        upProAccept.setApplyerName("张三");
        upProAccept.setApplyerPageCode("320826199109090808");
        upProAccept.setApplyerPageType("111");
        upProAccept.setApplyerType("2");
        upProAccept.setAreaId("33221314515");
        upProAccept.setCatalogCode("21312412412");
        upProAccept.setCdBatch(cdBatch);
        upProAccept.setCdOperation("I");
        upProAccept.setCdTime(DateUtil.getCurrentDateTime());
        upProAccept.setContractCode("");
        upProAccept.setContractMobile("13922929720");
        upProAccept.setContractName("");
        upProAccept.setContractType("");
        upProAccept.setDataSource("ces");
        upProAccept.setEnterpriseName("测试企业");
        upProAccept.setHandleUserName("");
        upProAccept.setIsItemBase("0");
        upProAccept.setLegal("高波");
        upProAccept.setLocalCatalogCode("");
        upProAccept.setLocalItemCode("21312412412");
        upProAccept.setLocalProjectNo("21321");
        upProAccept.setLocalTaskCode("324234");
        upProAccept.setOrgCode("223400");
        upProAccept.setOrgName("城关派出所");
        upProAccept.setProjectName(activity.getFullName());
        upProAccept.setProjectNo("1112689i6760");
        upProAccept.setProjectType("2");
        upProAccept.setPromiseDate("2022-09-22");
        upProAccept.setPromiseTime("2");
        upProAccept.setRowGuid("21321"+"_"+activity.getId());
        upProAccept.setTaskCode("12123");
        upProAccept.setTaskName("居住登记");
        upProAccept.setTaskVersion("1.0");
        upProAccept.setZipCode("");
        upProAccept.setTaskHandleItem("11121221212");
        upProAccept.setCompanyCode("2132144123412");
        upProAccept.setHandleUserId("测试人");
        upProAccept.setFileId("325");
        upProAccept.setPcc("户证");
        upProAccept.setSys_name("测试");
        upProAccept.setSys_lev("1");
        upProAccept.setModel_id("21312412412");
        return upProAccept;
    }
    private List<UpProProcess> setUpProProcessList(Activity activity){
        List<ApproveHistory> approveList = approveHistoryMapper.findByActivityId(activity.getId());
//        List<ActivityApproval> approveList = activityApprovalDao.findByActivityIdAndApproveStatus(activity.getOid(),"");
//        String approveUnit = activityService.getApproveUnit(activity);
        List<UpProProcess> list = Lists.newArrayList();
        UpProProcess upProProcess = null;
        for(ApproveHistory approve : approveList){
            upProProcess = new UpProProcess();
            upProProcess.setCdBatch(IdUtil.simpleUUID());
            upProProcess.setCdOperation("I");
            upProProcess.setCdTime(DateUtil.getCurrentDateTime());
            upProProcess.setDataSource("ces");
            upProProcess.setEventEndTime(BcxinDateUtil.diffFormatChina_F(approve.getAddTime(),approve.getElapsed()));
            upProProcess.setEventName(getEventName(approve.getApprove()));
            upProProcess.setEventStartTime(DateUtils.parseDateToStr(DateUtils.YYYY_MM_DD_HH_MM_SS,approve.getAddTime()));
            upProProcess.setHandleExplain(StringUtils.isEmpty(approve.getOpinion())?"无":approve.getOpinion());
            upProProcess.setHandleUserName(approve.getUserName());
            upProProcess.setProcessId("21321"+"AL"+approve.getId());
            upProProcess.setProcessName(getProcessName(approve.getApproveType()));
            upProProcess.setProjectNo("1112689i6760");
            upProProcess.setRemark(approve.getRemark());
            upProProcess.setIsNeedService("0");
            upProProcess.setServiceName("");
            upProProcess.setServiceNumber("");
            upProProcess.setServiceTime("");
            list.add(upProProcess);
        }
        return list;
    }
    private String getEventName(String status){
        if(StringUtils.isEmpty(status)){
            return "9";
        }
        //业务动作 1  通过2  退回9  其他
        if(status.equals("30")||status.equals("SL30")||status.equals("YES")||status.equals("GRADE")){
            return "1";
        } else if(status.equals("20")||status.equals("SL20")||status.equals("NO")){
            return "2";
        }else{
            return "9";
        }
    }
    private String getProcessName(String status){
        return status.equals("10")?"初审":status.equals("20")?"受理":status.equals("30")?"办结":status.equals("40")?"转交":"";
    }

    private UpProResult setUpProResult(Activity activity,String cdBatch){
        ApproveHistory approve = approveHistoryMapper.findByActivityIdAndApproveType(activity.getId(),DictConst.APPROVETYPE_SP,DictConst.STATUS_YES);
        String resultType = "1";
        String resultExplain = "批准";
        if (approve==null) {
            approve = approveHistoryMapper.findByActivityIdAndApproveType(activity.getId(),DictConst.APPROVETYPE_SP,DictConst.STATUS_NO);
            resultType = "0";
            resultExplain = "不予批准";
        }
        if(approve==null){
            return new UpProResult();
        }
        UpProResult upProResult = new UpProResult();
        upProResult.setCdBatch(cdBatch);
        upProResult.setCdOperation("I");
        upProResult.setCdTime(DateUtil.getCurrentDateTime());
        upProResult.setDataSource("ces");
        upProResult.setHandleUserName(approve.getUserName());
        upProResult.setIsDeliveryResults("0");
        upProResult.setProjectNo("1112689i6760");
        upProResult.setRemark(approve.getOpinion());
        upProResult.setResultCertName("");
        upProResult.setResultCetrNo("");
        upProResult.setResultDate(BcxinDateUtil.diffFormatChina_F(approve.getAddTime(),approve.getElapsed()));
        upProResult.setResultExplain(resultExplain);
        upProResult.setResultType(resultType);
        upProResult.setRowGuid("21321"+"_"+activity.getId());
        upProResult.setSatisfaction("");
        return upProResult;
    }
    private List<UpProMaterial> setUpProMaterialList(Activity activity){
        List<UpProMaterial> list = Lists.newArrayList();
        ActivityMaterial materialList = activityMaterialMapper.findByActivityId(activity.getId());
        setUpProMaterial(list,activity,"报批材料（许可审批材料）",materialList.getBpcl());
        setUpProMaterial(list,activity,"评估材料",materialList.getPgcl());
        setUpProMaterial(list,activity,"评估报告",materialList.getPgbg());
        setUpProMaterial(list,activity,"评估报告出具方",materialList.getPgbgProvider());
        setUpProMaterial(list,activity,"受理文书",materialList.getSlws());
        setUpProMaterial(list,activity,"监理检查表",materialList.getJljcb());
        setUpProMaterial(list,activity,"监理报告",materialList.getJlbg());
        setUpProMaterial(list,activity,"许可决定书",materialList.getXkjds());
        setUpProMaterial(list,activity,"安全工作方案",materialList.getAqgzfa());
        setUpProMaterial(list,activity,"安全许可审批表",materialList.getAqxkspb());
        return list;
    }

    private void setUpProMaterial(List<UpProMaterial> list,Activity activity,String typeName,String url){
        if(StringUtils.isEmpty(url)){
            return;
        }
        url = url.startsWith("http")?url: ConfigUtil.getValue("web_url")+url;
        UpProMaterial upProMaterial = new UpProMaterial();
        upProMaterial.setCdBatch(IdUtil.simpleUUID());
        upProMaterial.setCdOperation("I");
        upProMaterial.setCdTime(DateUtil.getCurrentDateTime());
        upProMaterial.setDataSource("ces");
        upProMaterial.setGetNum("");
        upProMaterial.setGetType("2");
        upProMaterial.setMaterialAttachName(url.substring(url.lastIndexOf("/")+1));
        upProMaterial.setMaterialName(typeName);
        upProMaterial.setProjectNo("1112689i6760");
        upProMaterial.setRemark("");
        upProMaterial.setRowGuid("21321"+"_"+activity.getId());
        upProMaterial.setUrl(url);
        list.add(upProMaterial);
    }

    private List<UpProSpecialProcedure> setUpProSpecialProcedureList(Activity activity, String cdBatch){
        return Lists.newArrayList();
    }

    private String getToken(){
        JSONObject json = new JSONObject();
        json.put("clientId",ConfigUtil.getValue("NX_CLIENTID"));
        json.put("secretId", SMEncryptUtil.sm3Encrypt(ConfigUtil.getValue("NX_SECRETID")));
        json.put("timestamp",System.currentTimeMillis()+"");
        String ret = HttpUtil.post(ConfigUtil.getValue("NX_QUERY_URL")+"res_token",json.toJSONString());
        if(StringUtils.isNotEmpty(ret)){
            ResultNX result = JSONObject.parseObject(ret,ResultNX.class);
            if(result.getCode()==200&&result.getData()!=null){
                return result.getData().getToken();
            }
        }
        return "";
    }

    public static void main(String[] args) {
        /*JSONObject json = new JSONObject();
        json.put("clientId",clientId);
        json.put("secretId",secretId);
        json.put("timestamp",System.currentTimeMillis()+"");
        String ret = HttpUtil.post(apiUrl+"res_token",json.toJSONString());
        if(StringUtils.isNotEmpty(ret)){
            ResultNX result = JSONObject.parseObject(ret,ResultNX.class);
            if(result.getCode()==200&&result.getData()!=null){
                System.out.println(result.getData().getToken());
                return;
            }
        }*/
        /*String fName = "/getResource.do?path=zhejiang/2019-10-28/hd/_act_16_t_20191028154007428.zip";
        String  fileName = fName.substring(fName.lastIndexOf("/")+1);
        System.out.println(fileName);*/
        JSONObject json = new JSONObject();
        json.put("clientId","");
        json.put("secretId", SMEncryptUtil.sm3Encrypt(""));
        json.put("timestamp",System.currentTimeMillis()+"");
        System.out.println(json.toJSONString());
    }
}
