package com.bcxin.sp.work.service.upgrade;

import com.bcxin.sp.work.dao.upgrade.SystemUpgradeMapper;
import com.bcxin.sp.work.entity.domain.upgrade.SystemUpgrade;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * @author hzp
 * 系统升级内容记录 service 层
 */
@Service
@Transactional
public class SystemUpgradeService{

    @Autowired
    private SystemUpgradeMapper mapper;

    /**
     * 新增
     * @param entity
     */
    public void insert(SystemUpgrade entity){
        mapper.insert(entity);
    }

    /**
     * 修改
     * @param entity
     */
    public void update(SystemUpgrade entity){
        mapper.updateById(entity);
    }

    /**
     * 查找需要的升级提示
     * @return
     */
    public SystemUpgrade findUpgrade(){
        return mapper.findUpgrade();
    }

    public List<SystemUpgrade> findAll(){
        return mapper.findAll();
    }

    public SystemUpgrade findUpgradeByPssId(Long pssId){
        return mapper.findUpgradeByPssId(pssId);
    }

    public SystemUpgrade findById(Long id){
        return mapper.findById(id);
    }

}
