package com.bcxin.sp.work.service.upgrade;

import com.bcxin.sp.work.dao.upgrade.SystemUpgradeUserMapper;
import com.bcxin.sp.work.entity.domain.upgrade.SystemUpgradeUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * @author hzp
 * 系统升级与人员关系记录 service层
 */
@Service
@Transactional
public class SystemUpgradeUserService {

    @Autowired
    private SystemUpgradeUserMapper mapper;

    /**
     * 新增
     * @param entity
     */
    public void insert(SystemUpgradeUser entity){
        mapper.insert(entity);
    }

    /**
     * 修改
     * @param entity
     */
    public void update(SystemUpgradeUser entity){
        mapper.updateById(entity);
    }

    /**
     * 验证用户是否已经读取了升级提示
     * @param userId
     * @param upgradeId
     * @return
     */
    public boolean checkUpgradeWithUser(Long userId,Long upgradeId){
        int num=mapper.checkUpgradeWithUser(userId,upgradeId);
        if(num>0){
            return Boolean.TRUE;
        }
        return Boolean.FALSE;
    }


}
