package com.bcxin.sp.work.service.user;

import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.bcxin.sp.work.dao.sys.MessageMapper;
import com.bcxin.sp.work.entity.domain.activity.base.Activity;
import com.bcxin.sp.work.entity.domain.user.User;
import com.bcxin.sp.work.util.Const.DictConst;
import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Map;

/**
 * 首页service
 */
@Service
@Transactional
public class PCService {

    @Autowired
    private MessageMapper messageMapper;

    /**
     * 消息汇总信息
     * @return
     */
    public Map<String,Long> messageTotal(User user){
        Long readTotal = messageMapper.findStatusCountOfMessage(user.getId(), DictConst.Y);
        Long unReadTotal = messageMapper.findStatusCountOfMessage(user.getId(), DictConst.N);
        Map<String,Long> messageMap = Maps.newHashMap();
        messageMap.put("readTotal",readTotal);
        messageMap.put("unReadTotal",unReadTotal);
        return messageMap;
    }

    /**
     * 审核汇总信息
     * @return
     */
    public Map<String,Integer> approveTotal(User user){
        /* 待审核*/
        EntityWrapper<Activity> wrapper1 = new EntityWrapper<Activity>();
        wrapper1.eq("province",user.getProvince());
        wrapper1.eq("city",user.getCity());
        wrapper1.eq("area",user.getArea());
        wrapper1.in("approveStatus", Lists.newArrayList(DictConst.STATUS_CSZ,DictConst.STATUS_SLZ,DictConst.STATUS_IN));

        /* 已许可*/
        EntityWrapper<Activity> wrapper2 = new EntityWrapper<Activity>();
        wrapper2.eq("province",user.getProvince());
        wrapper2.eq("city",user.getCity());
        wrapper2.eq("area",user.getArea());
        wrapper2.eq("approveStatus",DictConst.STATUS_YES);

        /* 已报备*/
        EntityWrapper<Activity> wrapper3 = new EntityWrapper<Activity>();
        wrapper3.eq("province",user.getProvince());
        wrapper3.eq("city",user.getCity());
        wrapper3.eq("area",user.getArea());
        wrapper3.eq("approveStatus",DictConst.STATUS_YES);
        wrapper3.eq("isBackUp",DictConst.Y);

        //List<Activity> dsh = activityMapper.selectList(wrapper1);
        //List<Activity> yxk = activityMapper.selectList(wrapper2);
        //List<Activity> ybb = activityMapper.selectList(wrapper3);
        Map<String,Integer> approveMap = Maps.newHashMap();
        //approveMap.put("dsh",activityService.filterApprove(user,dsh).size());
        //approveMap.put("yxk",activityService.filterApprove(user,yxk).size());
        //approveMap.put("ybb",activityService.filterApprove(user,ybb).size());
        return approveMap;
    }

}
