package com.bcxin.sp.work.timer;

import com.bcxin.sp.work.service.user.zj.PlatCommunicateService;
import com.bcxin.sp.work.util.Const.GlobalConst;
import com.bcxin.sp.work.util.sys.ConfigUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;

/**
 * <b>Function </b> 同步浙江数据
 *
 * @author LuoPeng
 * @注意事项 </b>
 * <b>
 */
@Service
@Transactional
@Slf4j
public class SyncZJService {


    @Resource
    private PlatCommunicateService platCommunicateService;

    /**
     * 同步浙江警综用户信息，增量
     * @throws Exception
     */
    public void syncUserData() {
        if (GlobalConst.ENVI_ZHEJIANG.endsWith(ConfigUtil.getValue("envi"))) {
            log.info("同步浙江警综用户信息，增量");
            platCommunicateService.syncUserData();
        }
    }

}
