package com.bcxin.sp.work.util.Const;

import com.bcxin.sp.work.entity.dto.ApproveRoleDTO;
import com.google.common.collect.Lists;

import java.util.List;

/**
 * 常量库
 * @author 罗鹏
 */
public class DictConst {

	/* 公共的 */
	public final static String Y = "1";//是
	public final static String N = "0";//否


	public final static int OP_LOGIN = 0;
	public final static int OP_SELECT = 1;
	public final static int OP_SAVE = 2;
	public final static int OP_UPDATE = 3;
	public final static int OP_DELETE = 4;


	/* 角色 */
	public final static String ROLE_SUPERADMIN = "SUPERADMIN";//超级管理员
	public final static String ROLE_ADMIN = "ADMIN";//管理员
	public final static String ROLE_EXPORT = "EXPORT";//导出
	public final static String ROLE_ADMIN_APPROVE = "ADMIN_APPROVE";//管理员兼审批
	public final static String ROLE_APPROVE = "APPROVE";//审批
	public final static String ROLE_READ = "READ";//阅读
	public final static String ROLE_DOWNLOAD = "DOWNLOAD";//下载
	public final static String ROLE_ZDHD = "ZDHD";//重大活动

	/* 菜单级别 */
	public final static String MENULEVEL_ONE = "1";//第一级
	public final static String MENULEVEL_TWO = "2";//第二级

	/* 同步审批类型 */
	public final static String SYNCTASKTYPE_CS = "10";//初审
	public final static String SYNCTASKTYPE_SL = "20";//受理
	public final static String SYNCTASKTYPE_SP = "30";//审批
	public final static String SYNCTASKTYPE_TRANSFER = "40";//转交

	/* 审批类型 */
	public final static String APPROVETYPE_CS = "10";//初审
	public final static String APPROVETYPE_YJ_XCKC = "11";//审批意见 要求进行现场勘查
	public final static String APPROVETYPE_YJ_BCCL = "12";//审批意见 要求提供补充材料
	public final static String APPROVETYPE_SL = "20";//受理
	public final static String APPROVETYPE_SP = "30";//审批
	public final static String APPROVETYPE_TRANSFER = "40";//转交

	/* 审批级别 */
	public final static String APPROVELEVEL_PROVINCE = "1";//省级审批
	public final static String APPROVELEVEL_CITY = "2";//市级审批
	public final static String APPROVELEVEL_AREA = "3";//区级审批

	/* 初审状态 */
	public final static String STATUS_CSZ = "10"; //初审中（承办提交初审）
	public final static String STATUS_SQCP = "15";//承办方申请重评（承办方申请重评）
	public final static String STATUS_CSXG = "20";//初审修改（初审不通过）
	public final static String STATUS_CSTG = "30";//初审通过（初审通过）

	/* 受理状态 */
	public final static String STATUS_SLZ = "SL10"; //受理中
	public final static String STATUS_BSL = "SL20";//不受理
	public final static String STATUS_SL = "SL30";//受理通过

	/* 许可审批状态*/
	public final static String STATUS_NONE = "NONE"; //未审核
	public final static String STATUS_IN = "IN"; //审核中
	public final static String STATUS_YES = "YES"; //许可
	public final static String STATUS_NO = "NO";//不许可
	public final static String STATUS_REJECT = "REJECT";//打回
	public final static String STATUS_TRANSFER = "TRANSFER";//转交


	/*文书名称*/
	public final static String FILE_NAME_BYSL = "大型群众性活动安全许可申请不予受理决定书";
	public final static String FILE_NAME_SL = "大型群众性活动安全许可申请受理凭证";
	public final static String FILE_NAME_BYXK = "大型群众性活动不予安全许可决定书";
	public final static String FILE_NAME_XK = "大型群众性活动安全许可决定书";



	public static List<String> fullSPList(){
		List<String> list = Lists.newArrayList();
		list.add(STATUS_NONE);
		list.add(STATUS_IN);
		list.add(STATUS_YES);
		list.add(STATUS_NO);
		list.add(STATUS_REJECT);
		return list;
	}

	public static List<ApproveRoleDTO> fullRoleList(){
		List<ApproveRoleDTO> list = Lists.newArrayList();
		list.add(new ApproveRoleDTO(ROLE_SUPERADMIN,"超级管理员"));
		list.add(new ApproveRoleDTO(ROLE_ADMIN,"管理员"));
		list.add(new ApproveRoleDTO(ROLE_EXPORT,"导出人员"));
		list.add(new ApproveRoleDTO(ROLE_ADMIN_APPROVE,"全权限人员"));
		list.add(new ApproveRoleDTO(ROLE_APPROVE,"审批人员"));
		list.add(new ApproveRoleDTO(ROLE_READ,"查看人员"));
		list.add(new ApproveRoleDTO(ROLE_DOWNLOAD,"下载人员"));
		return list;
	}

	public static List<ApproveRoleDTO> simpleRoleList(){
		List<ApproveRoleDTO> list = Lists.newArrayList();
		list.add(new ApproveRoleDTO(ROLE_ADMIN,"管理员"));
		list.add(new ApproveRoleDTO(ROLE_ADMIN_APPROVE,"全权限人员"));
		list.add(new ApproveRoleDTO(ROLE_APPROVE,"审批人员"));
		list.add(new ApproveRoleDTO(ROLE_READ,"查看人员"));
		list.add(new ApproveRoleDTO(ROLE_DOWNLOAD,"下载人员"));
		return list;
	}
}
