package com.bcxin.sp.work.util.sys;

import com.bcxin.sp.work.entity.domain.activity.base.Activity;
import com.bcxin.sp.work.util.BcxinDateUtil;
import com.bcxin.sp.work.util.Const.DictConst;
import com.google.common.collect.Maps;
import lombok.extern.slf4j.Slf4j;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.Resource;

import java.io.File;
import java.io.IOException;
import java.util.Date;
import java.util.Map;

@Slf4j
public class ApproveFileGenerator {
	
	public static File generateApproveFile(Activity activity) throws IOException {
		Resource fileRource = null;
		if ( DictConst.STATUS_YES.equals(activity.getApproveStatus()) ) {
			fileRource = new ClassPathResource("/approveFile.docx");
		} else if ( DictConst.STATUS_NO.equals(activity.getApproveStatus()) ) {
			fileRource = new ClassPathResource("/approveRejectFile.docx");
		}
		if ( fileRource == null) {
			return null;
		}
		String srcPath = fileRource.getFile().getAbsolutePath();
		String approvePath = ConfigUtil.getValue("approve-path");
		String tempPath = ConfigUtil.getValue("temp-path");
		String destPath = approvePath + System.currentTimeMillis() + ".docx";
		log.info("dest path: " + destPath);
		File dir = new File(approvePath);
		if(!dir.exists()) {
			dir.mkdirs();
		}
		Map<String, String> map = Maps.newHashMap();
		map.put("area", activity.getCity() + activity.getArea());
		map.put("are", activity.getArea().charAt(0)+"");
		map.put("organizer", activity.getSponsor());
		map.put("updateDate", BcxinDateUtil.chinaDate.format(activity.getUpdateTime()));
		map.put("name", activity.getFullName());
		map.put("startTime", BcxinDateUtil.chinaTime.format(activity.getStartDate()));
		map.put("endTime", BcxinDateUtil.chinaTime.format(activity.getEndDate()));
		map.put("address", activity.getAddress());
		map.put("today", BcxinDateUtil.chinaDate.format(new Date()));
		log.info("begin to generate, activity is:" + activity);
		boolean result = WordUtil.replaceAndGenerateWord(srcPath, destPath, tempPath, map);
		if(result) {
			log.info("generate successful!");
			return new File(destPath);
		}
		log.error("generate error!");
		return null;
	}
	
}
