package com.bcxin.sp.work.util.sys;

import org.apache.poi.POIXMLDocument;
import org.apache.poi.xwpf.usermodel.*;
import org.springframework.util.FileCopyUtils;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

public class WordUtil {
	
	// 替换word中需要替换的特殊字符
    public static boolean replaceAndGenerateWord(String srcPath, String destPath, String tempPath, Map<String, String> map) throws IOException {
        String[] sp = srcPath.split("\\.");
        String[] dp = destPath.split("\\.");
        if ((sp.length > 0) && (dp.length > 0)) {// 判断文件有无扩展名
            // 比较文件扩展名
            if (sp[sp.length - 1].equalsIgnoreCase("docx")) {
            	File srcFile = new File(srcPath);
            	tempPath = tempPath + "replace_file_temp_" + new Date().getTime() + ".docx";
            	File tempFile = new File(tempPath);
            	FileCopyUtils.copy(srcFile, tempFile);
                XWPFDocument document = new XWPFDocument(POIXMLDocument.openPackage(tempPath));
                // 替换段落中的指定文字
                Iterator<XWPFParagraph> itPara = document
                        .getParagraphsIterator();
                while (itPara.hasNext()) {
                    XWPFParagraph paragraph = (XWPFParagraph) itPara.next();
                    List<XWPFRun> runs = paragraph.getRuns();
                    for (int i = 0; i < runs.size(); i++) {
                        String oneparaString = runs.get(i).getText(
                                runs.get(i).getTextPosition());
                        for (Entry<String, String> entry : map
                                .entrySet()) {
                            oneparaString = oneparaString.replace(
                                    entry.getKey(), entry.getValue());
                        }
                        runs.get(i).setText(oneparaString, 0);
                    }
                }
                // 替换表格中的指定文字
                Iterator<XWPFTable> itTable = document.getTablesIterator();
                while (itTable.hasNext()) {
                    XWPFTable table = (XWPFTable) itTable.next();
                    int rcount = table.getNumberOfRows();
                    for (int i = 0; i < rcount; i++) {
                        XWPFTableRow row = table.getRow(i);
                        List<XWPFTableCell> cells = row.getTableCells();
                        for (XWPFTableCell cell : cells) {
                            String cellTextString = cell.getText();
                            for (Entry<String, String> e : map.entrySet()) {
                                if (cellTextString.contains(e.getKey()))
                                    cellTextString = cellTextString
                                            .replace(e.getKey(),
                                                    e.getValue());
                            }
                            cell.removeParagraph(0);
                            cell.setText(cellTextString);
                        }
                    }
                }
                FileOutputStream outStream = null;
                outStream = new FileOutputStream(destPath);
                document.write(outStream);
                outStream.close();
                document.close();
                return true;
            } else {
            	throw new RuntimeException("仅支持docx");
            }
        } else {
            return false;
        }
    }

}
